'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./App.css');

require('./ui/ui.less');

var _Tree = require('./components/Tree');

var _Tree2 = _interopRequireDefault(_Tree);

var _TreeNodeData = require('./core/TreeNodeData');

var _TreeNodeData2 = _interopRequireDefault(_TreeNodeData);

var _Routers = require('./demo/Routers');

var _Routers2 = _interopRequireDefault(_Routers);

var _Config = require('./demo/Config');

var _Config2 = _interopRequireDefault(_Config);

var _head = require('./ui/head');

var _head2 = _interopRequireDefault(_head);

var _reactRouterDom = require('react-router-dom');

var _Index = require('./demo/Index');

var _Index2 = _interopRequireDefault(_Index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import TextInput from './components/TextInput';

var App = function (_Component) {
  _inherits(App, _Component);

  function App(props) {
    _classCallCheck(this, App);

    var _this = _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).call(this, props));

    _this.tree_changeHandler = function (event) {
      window.location.hash = event.data.value.hash;
    };

    _this.tbKey_enterHandler = function (value) {
      _this.switchToKey(value);
    };

    var treeData = [new _TreeNodeData2.default({ hash: 'ButtonDemo', label: '按钮' }), new _TreeNodeData2.default({ hash: 'ToggleButtonDemo', label: '切换按钮' }), new _TreeNodeData2.default({ hash: 'SwitchDemo', label: '开关' }), new _TreeNodeData2.default({ hash: 'RadioButtonDemo', label: '单选框' }), new _TreeNodeData2.default({ hash: 'CheckBoxDemo', label: '多选框' }), new _TreeNodeData2.default({ hash: 'TextInputDemo', label: '文本框' }), new _TreeNodeData2.default({ hash: 'NumberSteperDemo', label: '步进输入框' }), new _TreeNodeData2.default({ hash: 'ProgressBarDemo', label: '进度条' }), new _TreeNodeData2.default({ hash: 'PickerDemo', label: '滑动选择器' }), new _TreeNodeData2.default({ hash: 'AlertDemo', label: '警告框' }), new _TreeNodeData2.default({ hash: 'TitleWindowDemo', label: '窗口' }), new _TreeNodeData2.default({ hash: 'DropListDemo', label: '下拉框' }), new _TreeNodeData2.default({ hash: 'BreadcrumbDemo', label: '面包屑' }), new _TreeNodeData2.default({ hash: 'MenuDemo', label: '菜单' }), new _TreeNodeData2.default({ hash: 'TreeDemo', label: '树' }), new _TreeNodeData2.default({ hash: 'HSliderDemo', label: '滑块' }), new _TreeNodeData2.default({ hash: 'ListDemo', label: '列表' }), new _TreeNodeData2.default({ hash: 'ViewStackDemo', label: '选项卡' }), new _TreeNodeData2.default({ hash: 'ChangeSkinDemo', label: '动态换肤', noApi: true }), new _TreeNodeData2.default({ hash: 'DragerDemo', label: '拖动器' }), new _TreeNodeData2.default({ hash: 'LoaderDemo', label: '加载器' }), new _TreeNodeData2.default({ hash: 'SystemUtilDemo', label: '系统辅助' }), new _TreeNodeData2.default({ hash: 'TimerDemo', label: '定时器' })];

    _this.state = {
      treeData: treeData
    };
    return _this;
  }

  _createClass(App, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.selectedByHash();

      window.onhashchange = function (event) {
        _this2.selectedByHash();
      };
    }
  }, {
    key: 'selectedByHash',
    value: function selectedByHash() {
      if (this.refs.tree) {
        var key = window.location.hash;
        key = key.substring(key.indexOf('#/') + 2);

        var selectedValue = this.refs.tree.selectedValue;
        if (!selectedValue || key !== selectedValue.value.hash) {
          this.switchToKey(key);
        }
      }
    }
  }, {
    key: 'pbLabelFun',
    value: function pbLabelFun(value, maxValue) {
      return value + '/' + maxValue;
    }
  }, {
    key: 'switchToKey',
    value: function switchToKey(key) {
      if (key) {
        var item = this.search(key);
        if (item) {
          this.refs.tree.selectedValue = item;
        }
      }
    }
  }, {
    key: 'search',
    value: function search(key) {
      for (var i = 0; i < this.state.treeData.length; i++) {
        var item = this.state.treeData[i];
        if (item.value.label.indexOf(key) >= 0 || item.value.hash.toLowerCase().indexOf(key.toLowerCase()) >= 0) {
          return item;
        }
      }
      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      // return <TextInput maxChars={10}/>;
      return _react2.default.createElement(
        'div',
        { className: 'demo' },
        _react2.default.createElement(_head2.default, { onSearch: this.tbKey_enterHandler }),
        _react2.default.createElement(
          _reactRouterDom.HashRouter,
          null,
          _react2.default.createElement(
            _reactRouterDom.Switch,
            null,
            _react2.default.createElement(_reactRouterDom.Route, { path: '/', component: _Index2.default, exact: true }),
            _react2.default.createElement(
              _reactRouterDom.Route,
              null,
              _react2.default.createElement(
                'div',
                { className: 'content' },
                _react2.default.createElement(_Tree2.default, { ref: 'tree', className: 'componentTree', data: this.state.treeData, changeHandler: this.tree_changeHandler,
                  labelFunction: function labelFunction(data) {
                    return _react2.default.createElement(
                      'div',
                      null,
                      _react2.default.createElement(
                        'span',
                        null,
                        data.value.label
                      ),
                      !data.value.noApi && _react2.default.createElement(
                        'a',
                        { className: 'href-api', href: _Config2.default.URL + 'out/' + data.value.hash.replace('Demo', '') + '.html', target: '_blank' },
                        'API\u6587\u6863'
                      )
                    );
                  } }),
                _react2.default.createElement(
                  'div',
                  { className: 'componentCanvas' },
                  _react2.default.createElement(_Routers2.default, null)
                )
              )
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'contact' },
          _react2.default.createElement(
            'div',
            null,
            'DEMO\u4F5C\u8005: \u5F90\u4FCA\u6770  \u90D1\u7D20\u7D20'
          ),
          _react2.default.createElement(
            'div',
            null,
            '\u6709\u95EE\u9898\u8BF7\u8054\u7CFB: yinhunfeixue@163.com'
          )
        )
      );
    }
  }]);

  return App;
}(_react.Component);

exports.default = App;
//# sourceMappingURL=App.js.map