'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _TitleWindow2 = require('./TitleWindow');

var _TitleWindow3 = _interopRequireDefault(_TitleWindow2);

var _PopupManager = require('../manager/PopupManager');

var _PopupManager2 = _interopRequireDefault(_PopupManager);

var _AlertSkin = require('../skins/AlertSkin');

var _AlertSkin2 = _interopRequireDefault(_AlertSkin);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _DataEvent = require('../events/DataEvent');

var _DataEvent2 = _interopRequireDefault(_DataEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 弹出式警告框，可设置显示的按钮以及点击点击按钮关闭后的处理函数
 * 
 * <h3>皮肤部件</h3>
 * <ol>
 * 	<li>buttonOk 确定按钮</li>
 * 	<li>buttonOk 取消按钮</li>
 * </ol>
 * 
 * @example <caption>显示文本内容</caption>
 * Alert.show('标题', '我是一长串文字', this.alerCloseHandler, [Alert.OK, Alert.CANCEL]);
 * 
 * alerCloseHandler = (event) =>{
 *  if(event.data === Alert.OK){
 *   console.log('点击了确认按钮');
 *  }
 *  else if(event.data === Alert.CANCEL){
 *   console.log('点击了取消按钮');
 *  }
 *  else{
 *   console.log('点击了窗口关闭按钮或者通过其它方式关闭');
 *  }
 * }
 * 
 * @example <caption>显示自定义内容</caption>
 * Alert.show('标题', <div><span>我是一个标签</span><a>我是一个链接</a></div>, 
 *    this.alerCloseHandler, [Alert.OK, Alert.CANCEL]);
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-22 08:50:58
 * 
 * @extends TitleWindow
 * 
 */
var Alert = function (_TitleWindow) {
	_inherits(Alert, _TitleWindow);

	function Alert() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Alert);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Alert.__proto__ || Object.getPrototypeOf(Alert)).call.apply(_ref, [this].concat(args))), _this), _this._closeButtonClickHandler = function (event) {
			_this._close(null);
		}, _this.btnOkClickHandler = function (event) {
			_this._close(Alert.OK);
		}, _this.btnCancelClickHandler = function (event) {
			_this._close(Alert.CANCEL);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Alert, [{
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(Alert.prototype.__proto__ || Object.getPrototypeOf(Alert.prototype), '_initProperty', this).call(this);
			this._buttonValues = [];
			this._buttonLabels = [];
			this._minEnable = false;
			this._maxEnable = false;
			this._content = null;
			this._dragEnable = true;
		}

		/**
   * 警告框内容
   * @private
   */

	}, {
		key: '_renderContent',


		/**
   * @private
   */
		value: function _renderContent() {
			if (this._content) {
				if (this.contentContainer) {
					_reactDom2.default.render(_react2.default.createElement(
						'span',
						null,
						this._content
					), this.contentContainer);
				}
			} else {
				_get(Alert.prototype.__proto__ || Object.getPrototypeOf(Alert.prototype), '_renderContent', this).call(this);
			}
		}

		/**
   * @private
   */

	}, {
		key: '_getDefaultSKinClass',


		/**
   * @inheritdoc
   */
		value: function _getDefaultSKinClass() {
			return _AlertSkin2.default;
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(Alert.prototype.__proto__ || Object.getPrototypeOf(Alert.prototype), '_initSkin', this).call(this);
			this._renderControl();
		}
	}, {
		key: '_unstallSkin',
		value: function _unstallSkin() {
			if (this.buttonOk) {
				this.buttonOk.rootComponent.removeEventListener('click', this.btnOkClickHandler);
			}
			if (this.buttonCancel) {
				this.buttonCancel.rootComponent.removeEventListener('click', this.btnCancelClickHandler);
			}

			_get(Alert.prototype.__proto__ || Object.getPrototypeOf(Alert.prototype), '_unstallSkin', this).call(this);
		}
		/**
   * @private
   */

	}, {
		key: '_renderControl',
		value: function _renderControl() {
			//更新按钮
			if (this.buttonOk) {
				this.buttonOk.style.display = 'none';
				this.buttonOk.rootComponent.addEventListener('click', this.btnOkClickHandler);
			}
			if (this.buttonCancel) {
				this.buttonCancel.style.display = 'none';
				this.buttonCancel.rootComponent.addEventListener('click', this.btnCancelClickHandler);
			}
			for (var i = 0; i < this._buttonValues.length; i++) {
				var btn = null;
				switch (this._buttonValues[i]) {
					case Alert.OK:
						btn = this.buttonOk;
						break;
					case Alert.CANCEL:
						btn = this.buttonCancel;
						break;
					default:
						break;
				}

				if (btn != null) {
					btn.style.display = '';
					btn.label = this._getButtonLabel(i);
				}
			}
		}
	}, {
		key: '_close',
		value: function _close(value) {
			if (this.props.closeFunction) {
				this.props.closeFunction();
			}
			this.dispatchEvent(new _DataEvent2.default(_DataEvent2.default.CLOSE, value));
		}

		/**
   * @private
   */

	}, {
		key: '_getButtonLabel',
		value: function _getButtonLabel(index) {
			if (this._buttonLabels != null && this._buttonLabels.length > index) {
				return this._buttonLabels[index];
			} else {
				switch (this._buttonValues[index]) {
					case Alert.OK:
						return Alert.OK_LABEL;
					case Alert.CANCEL:
						return Alert.CANCEL_LABEL;
					default:
						return '按钮';
				}
			}
		}

		/**
   * 皮肤部件，确定按钮
   * 
   * @type {HtmlNode}
   */

	}, {
		key: 'content',
		get: function get() {
			return this._content;
		},
		set: function set(value) {
			if (this._content !== value) {
				this._content = value;
				this._renderContent();
			}
		}
	}, {
		key: 'buttonValues',
		get: function get() {
			return this._buttonValues;
		},
		set: function set(value) {
			this._buttonValues = value;
			this.forceUpdate();
		}
	}, {
		key: 'buttonOk',
		get: function get() {
			return this.findSkinPart('buttonOk');
		}

		/**
   * 皮肤部件，取消按钮
   * 
   * @type {HtmlNode}
   */

	}, {
		key: 'buttonCancel',
		get: function get() {
			return this.findSkinPart('buttonCancel');
		}
	}], [{
		key: 'show',


		/**
   * 显示一个警告框
   * @param {string} title 窗口标题
   * @param {any} content 窗口内容，通常是一段文本，也可以是各种组件和其它任何内容
   * @param {function} closeHandler 事件类型{@link DataEvent#CLOSE}，可根据事件携带的数据判断点击的按钮
   * @param {array} buttonValues 按钮值数组。每一项应为Alert.OK、Alert.CANCEL之一
   * @param {array} buttonLabels 按钮文本数组，指定按钮显示的文本，和buttonValues一一对应，如果不设置，则使用默认值
   */
		value: function show(title, content, closeHandler, buttonValues) {
			var buttonLabels = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

			if (buttonValues == null) {
				buttonValues = [Alert.OK];
			}
			var alert = _react2.default.createElement(Alert, { titleText: title, content: content, closeHandler: closeHandler, buttonValues: buttonValues,
				closeFunction: function closeFunction() {
					_PopupManager2.default.removePopUp(alert);
				} });

			_PopupManager2.default.addPopUp(alert);
			return alert;
		}

		/**
   * 表示确定按钮的值
   * 
   * @type {number}
   * @readonly
   * @static
   * @memberof Alert
   */


		/**
   * 表示取消按钮的值
   * 
   * @type {number}
   * @readonly
   * @static
   * @memberof Alert
   */


		/**
   * @private
   */


		/**
   * @private
   */

	}]);

	return Alert;
}(_TitleWindow3.default);

Alert.OK = 1;
Alert.CANCEL = 2;
Alert.OK_LABEL = '确定';
Alert.CANCEL_LABEL = '取消';
exports.default = Alert;
//# sourceMappingURL=Alert.js.map