'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _BreadcrumbItemRenderSkin = require('../skins/BreadcrumbItemRenderSkin');

var _BreadcrumbItemRenderSkin2 = _interopRequireDefault(_BreadcrumbItemRenderSkin);

var _ItemRender2 = require('../components/supports/ItemRender');

var _ItemRender3 = _interopRequireDefault(_ItemRender2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 面包屑子项
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-29 14:24:47
 * 
 */
var Breadcrumb = function (_ItemRender) {
	_inherits(Breadcrumb, _ItemRender);

	function Breadcrumb() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Breadcrumb);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).call.apply(_ref, [this].concat(args))), _this), _this.clickHandler = function (event) {
			_this.selected = true;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Breadcrumb, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(Breadcrumb.prototype.__proto__ || Object.getPrototypeOf(Breadcrumb.prototype), '_initProperty', this).call(this);
			this._index = 0;
			this._count = true;
			this._hrefFunction = null;
		}
	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _BreadcrumbItemRenderSkin2.default;
		}
	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(Breadcrumb.prototype.__proto__ || Object.getPrototypeOf(Breadcrumb.prototype), '_initSkin', this).call(this);
			if (this.rootComponent) this.rootComponent.addEventListener('click', this.clickHandler);
		}
	}, {
		key: '_unstallSkin',
		value: function _unstallSkin() {
			if (this.rootComponent) this.rootComponent.removeEventListener('click', this.clickHandler);
			_get(Breadcrumb.prototype.__proto__ || Object.getPrototypeOf(Breadcrumb.prototype), '_unstallSkin', this).call(this);
		}
	}, {
		key: 'labelFunction',


		/**
   * 计算label属性的函数，格式为fun(data, index, count)
   * data--数据项
   * index--序号，从0开始
   * count--一共有多少项
   * @type {function}
   * @default null
   */
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 计算href属性的函数，格式为fun(data, index, count)
   * data--数据项
   * index--序号，从0开始
   * count--一共有多少项
   * @type {function}
   * @default null
   */

	}, {
		key: 'hrefFunction',
		get: function get() {
			return this._hrefFunction;
		},
		set: function set(value) {
			if (this._hrefFunction !== value) {
				this._hrefFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 获取显示的文字
   * 优选使用labelFunction计算，其次使用data.label，再次使用data.toString()。
   * 如果以上都不存在，则返回''
   * 
   * @readonly
   * @type {string}
   */

	}, {
		key: 'label',
		get: function get() {
			if (!this.data) return '';

			if (this._labelFunction) return this._labelFunction(this.data, this.index, this.count);else if (this.data.label) return this.data.label;else return this.data.toString();
		}

		/**
   * 获取显示的文字
   * 优选使用hrefFunction计算，其次使用data.href，再次使用data.toString()。
   * 如果以上都不存在，则返回''
   * 
   * @readonly
   * @type {string}
   */

	}, {
		key: 'href',
		get: function get() {
			if (!this.data) return '';

			if (this._hrefFunction) return this._hrefFunction(this.data, this.index, this.count);else if (this.data.href) return this.data.href;else return this.data.toString();
		}
	}, {
		key: 'count',
		get: function get() {
			return this._count;
		},
		set: function set(value) {
			if (this._count !== value) {
				this._count = value;
				this.forceUpdate();
			}
		}
	}, {
		key: 'index',
		get: function get() {
			return this._index;
		},
		set: function set(value) {
			if (this._index !== value) {
				this._index = value;
				this.forceUpdate();
			}
		}
	}]);

	return Breadcrumb;
}(_ItemRender3.default);

exports.default = Breadcrumb;
//# sourceMappingURL=BreadcrumItemRender.js.map