'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _UIComponent2 = require('./UIComponent');

var _UIComponent3 = _interopRequireDefault(_UIComponent2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BreadcrumItemRender = require('./BreadcrumItemRender');

var _BreadcrumItemRender2 = _interopRequireDefault(_BreadcrumItemRender);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 面包屑导航，用于显示多个层级的顺序，例如网站导航
 * 面包屑子项有两个主要属性
 * <ul>
 * 	<li>label--表示显示的文字，优先使用labelFunction计算，其次使用数据的label属性，再次使用data.toString()。如果都不存在，返回''</li>
 * 	<li>href--表示链接，，优先使用hrefFunction计算，其次使用数据的href属性，再次使用data.toString()。如果都不存在，返回''</li>
 * </ul>
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-29 14:24:47
 */
var Breadcrumb = function (_UIComponent) {
	_inherits(Breadcrumb, _UIComponent);

	function Breadcrumb() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Breadcrumb);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).call.apply(_ref, [this].concat(args))), _this), _this.item_changeHandler = function (event) {
			var target = event.currentTarget;
			if (target.selected) {
				_this.selectedIndex = target.index;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Breadcrumb, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(Breadcrumb.prototype.__proto__ || Object.getPrototypeOf(Breadcrumb.prototype), '_initProperty', this).call(this);
			this._data = [];
			this._itemClassType = _BreadcrumItemRender2.default;
			this._labelFunction = null;
			this._hrefFunction = null;
			this._selectedIndex = -1;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var elements = [];
			if (this._data && this._data.length > 0) {
				elements = this._data.map(function (value, index, array) {
					return _react2.default.createElement(_this2._itemClassType, {
						key: index,
						index: index,
						count: array.length,
						data: value,
						selected: _this2.selectedIndex === index,
						labelFunction: _this2._labelFunction,
						hrefFunction: _this2._hrefFunction,
						changeHandler: _this2.item_changeHandler
					});
				});
			}
			return _react2.default.createElement(
				'div',
				null,
				elements
			);
		}
	}, {
		key: 'selectedIndex',
		get: function get() {
			return this._selectedIndex;
		},
		set: function set(value) {
			if (this._selectedIndex !== value) {
				this._selectedIndex = value;
				this.forceUpdate();
			}
		}
		/**
   * 计算子项label属性的函数，格式为fun(data, index, count)
   * data--数据项
   * index--序号，从0开始
   * count--一共有多少项
   * @type {function}
   * @default null
   */

	}, {
		key: 'labelFunction',
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 计算子项href属性的函数，格式为fun(data, index, count)
   * data--数据项
   * index--序号，从0开始
   * count--一共有多少项
   * @type {function}
   * @default null
   */

	}, {
		key: 'hrefFunction',
		get: function get() {
			return this._hrefFunction;
		},
		set: function set(value) {
			if (this._hrefFunction !== value) {
				this._hrefFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 数据源，其中每一项表示一个子项的数据
   * @type {array}
   */

	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			if (this._data !== value) {
				this._data = value;
				this.forceUpdate();
			}
		}
	}]);

	return Breadcrumb;
}(_UIComponent3.default);

exports.default = Breadcrumb;
//# sourceMappingURL=Breadcrumb.js.map