'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _ButtonBase2 = require('./supports/ButtonBase');

var _ButtonBase3 = _interopRequireDefault(_ButtonBase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Button 组件是常用的矩形按钮，Button 组件看起来可以按压，可设置长按功能
 * 
 * @example <caption>创建基本按钮</caption>
 * <Button label='按钮' />
 * 
 * @example <caption>设置长按功能并自定义自动点击间隔时间</caption>
 * <Button label='按钮' autoRepeatClick={true} repeatIntervalTime={200} onClick={(event)=>{
 * 	//your code
 * }}/>
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/1 下午3:47:50
 * @extends ButtonBase
 */
var Button = function (_ButtonBase) {
	_inherits(Button, _ButtonBase);

	function Button() {
		_classCallCheck(this, Button);

		return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
	}

	_createClass(Button, [{
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(Button.prototype.__proto__ || Object.getPrototypeOf(Button.prototype), '_initProperty', this).call(this);
			this._autoRepeatClick = false;
			this._repeatIntervalTime = 200;
			this._repeatIntervalID = NaN;
		}

		/**
  	 * @private
  	 */

	}, {
		key: 'mouseEventHandler',
		value: function mouseEventHandler(event) {
			_get(Button.prototype.__proto__ || Object.getPrototypeOf(Button.prototype), 'mouseEventHandler', this).call(this, event);
			this._checkAutoReapt();
		}

		/**
   * @private
   */

	}, {
		key: '_checkAutoReapt',
		value: function _checkAutoReapt() {
			if (this.enable && this._autoRepeatClick && this._isMouseDown && this._isMouseOver) {
				this._startRepeatClick();
			} else {
				this._stopRepeatClick();
			}
		}

		/**
   * @private
   */

	}, {
		key: '_startRepeatClick',
		value: function _startRepeatClick() {
			if (isNaN(this._repeatIntervalID)) {
				this._repeatIntervalID = setInterval(this._autoClick.bind(this), this._repeatIntervalTime);
			}
		}
		/**
   * @private
   */

	}, {
		key: '_stopRepeatClick',
		value: function _stopRepeatClick() {
			clearInterval(this._repeatIntervalID);
			this._repeatIntervalID = NaN;
		}
		/**
   * @private
   */

	}, {
		key: '_autoClick',
		value: function _autoClick() {
			var event = window.document.createEvent('MouseEvents');
			event.initEvent('click', true, true);
			this.rootComponent.dispatchEvent(event);
		}

		/**
   * 按钮长按时，是否自动点击
   * @type {boolean}
   * @default false
   */

	}, {
		key: 'autoRepeatClick',
		get: function get() {
			return this._autoRepeatClick;
		},
		set: function set(value) {
			this._autoRepeatClick = value;
		}

		/**
   * 按钮长按时，自动点击的间隔时间（毫秒）
   * 此值最小值为50，如果小于此值，将被设置为50
   * @type {number}
   * @default 200
   */

	}, {
		key: 'repeatIntervalTime',
		get: function get() {
			return this._repeatIntervalTime;
		},
		set: function set(value) {
			if (value < 50) value = 50;
			this._repeatIntervalTime = value;
		}
	}]);

	return Button;
}(_ButtonBase3.default);

exports.default = Button;
//# sourceMappingURL=Button.js.map