'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _set = function set(object, property, value, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent !== null) { set(parent, property, value, receiver); } } else if ("value" in desc && desc.writable) { desc.value = value; } else { var setter = desc.set; if (setter !== undefined) { setter.call(receiver, value); } } return value; };

var _SkinableComponent2 = require('./SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _RemoteEvent = require('../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

var _DropListSkin = require('../skins/DropListSkin');

var _DropListSkin2 = _interopRequireDefault(_DropListSkin);

var _TextEvent = require('../events/TextEvent');

var _TextEvent2 = _interopRequireDefault(_TextEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * DropList 控件包含下拉列表，用户可从中选择单个值
 * 
 * @author xujunjie
 * @mail yinhunfeixue@163.com
 * @date 2017-11-20 14:10:32
 */
var DropList = function (_SkinableComponent) {
	_inherits(DropList, _SkinableComponent);

	function DropList() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, DropList);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DropList.__proto__ || Object.getPrototypeOf(DropList)).call.apply(_ref, [this].concat(args))), _this), _this.dropTextInput_clickHandler = function (event) {
			_this.isOpen = !_this.isOpen;
		}, _this.dropTextInput_changeHandler = function (event) {
			_this._key = event.currentTarget.text;
			_this._isOpen = true;
			_this._updateDropList();
			_this._updateSkinStatus();
		}, _this.dropList_changeHandler = function (event) {
			_this.selectedValue = event.currentTarget.selectedValue;
			_this.isOpen = false;
		}, _this.dropTextInput_enterHandler = function (event) {
			if (_this._inputAble) {
				var newItem = _this._createNewItem(event.currentTarget.text);
				if (newItem) {
					_this._data.push(newItem);
				}
				if (_this.isOpen) _this._updateDropList();
			}
			event.currentTarget.text = '';
		}, _this.document_clickHandler = function (event) {
			if (!_this.rootComponent || !_this.rootComponent.contains(event.target)) {
				_this.isOpen = false;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(DropList, [{
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _DropListSkin2.default;
		}

		/**
  * 
  * @type {}
  * @default 
  */

	}, {
		key: '_initProperty',
		value: function _initProperty() {
			_get(DropList.prototype.__proto__ || Object.getPrototypeOf(DropList.prototype), '_initProperty', this).call(this);
			this._data = [];
			this._isOpen = false;
			this._selectedIndex = -1;
			this._changeHandler = null;
			this._placeholder = '';
			this._labelFunction = null;
			this._displayData = [];
			this._key = null;
			this._searchFunction = null;
			this._searchAble = false;
			this._inputAble = false;
			this._newValueFunction = null;
		}
	}, {
		key: '_updateDisplayData',
		value: function _updateDisplayData() {
			if (this._searchAble && this._data && this._key && this._key.length > 0) {
				this._displayData = [];
				for (var i = 0; i < this._data.length; i++) {
					var element = this._data[i];
					if (this._compareItemAndKey(element, this._key)) {
						this._displayData.push(element);
					}
				}
			} else if (this._data) {
				this._displayData = this._data.concat();
			} else {
				this._displayData = [];
			}
		}
	}, {
		key: '_compareItemAndKey',
		value: function _compareItemAndKey(item, keyWord) {
			if (this._searchFunction) {
				return this._searchFunction(item, keyWord);
			} else {
				if (item) {
					if (item instanceof Object) {
						for (var key in item) {
							var property = item[key];
							if (property.indexOf(keyWord) >= 0) return true;
						}
					}
					if (item.toString().indexOf(keyWord) >= 0) return true;
				}
				return false;
			}
		}
	}, {
		key: '_createNewItem',
		value: function _createNewItem(text) {
			if (this._newValueFunction) {
				return this._newValueFunction(text);
			} else {
				return text;
			}
		}

		/**
   * 根据数据项，创建对应的显示文本
   * @param {object} itemData 数据，value值
   * @param {number} index 数据在集合中的位置
   * 
   * @private
   */

	}, {
		key: '_createLabel',
		value: function _createLabel(itemData, index) {
			//优先使用labelFunction,最后使用toString()
			if (itemData) {
				if (this._labelFunction) {
					return this._labelFunction(itemData, index);
				} else if (itemData.toString) {
					return itemData.toString();
				}
			}
			return '';
		}
	}, {
		key: '_updateLabel',
		value: function _updateLabel() {
			if (this.dropTextInput) {
				var item = this.selectedValue;
				var newText = null;
				if (item) {
					var label = this._createLabel(item, this.selectedIndex);
					newText = label;
				}

				if (newText !== this.dropTextInput.text) {
					this.dropTextInput.removeEventListener(_TextEvent2.default.TEXT_CHANGE, this.dropTextInput_changeHandler);
					this.dropTextInput.text = newText;
					this.dropTextInput.addEventListener(_TextEvent2.default.TEXT_CHANGE, this.dropTextInput_changeHandler);
				}
			}
		}
	}, {
		key: '_updateDropList',
		value: function _updateDropList() {
			if (this.dropList) {
				this.dropList.removeEventListener(_RemoteEvent2.default.CHANGE, this.dropList_changeHandler);
				this._updateDisplayData();
				this._key = null;
				this.dropList.data = this._displayData;
				this.dropList.selectedValue = this.selectedValue;
				if (this.isOpen) {
					this.dropList.addEventListener(_RemoteEvent2.default.CHANGE, this.dropList_changeHandler);
					document.addEventListener('click', this.document_clickHandler);
				} else {
					if (this.dropTextInput) {
						this.dropTextInput.focus();
					}
				}
			}
		}
	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(DropList.prototype.__proto__ || Object.getPrototypeOf(DropList.prototype), '_initSkin', this).call(this);
			if (this.dropTextInput) {
				this.dropTextInput.rootComponent.addEventListener('click', this.dropTextInput_clickHandler);
				this.dropTextInput.addEventListener(_TextEvent2.default.TEXT_CHANGE, this.dropTextInput_changeHandler);
				this.dropTextInput.addEventListener(_RemoteEvent2.default.ENTER, this.dropTextInput_enterHandler);
				this.dropTextInput.enable = this.enable;
				this.dropTextInput.editable = this._searchAble || this._inputAble;
				this.dropTextInput.placeholder = this._placeholder;
			}
			if (this.dropList) {
				this.dropList.labelFunction = this.labelFunction;
				this.dropList.enable = this.enable;
				this.dropList.data = this._data;
			}
			this._updateLabel();
		}
	}, {
		key: '_unstallSkin',
		value: function _unstallSkin() {
			if (this.dropTextInput) {
				this.dropTextInput.rootComponent.removeEventListener('click', this.dropTextInput_clickHandler);
				this.dropTextInput.removeEventListener(_TextEvent2.default.TEXT_CHANGE, this.dropTextInput_changeHandler);
				this.dropTextInput.removeEventListener(_RemoteEvent2.default.ENTER, this.dropTextInput_enterHandler);
			}
			_get(DropList.prototype.__proto__ || Object.getPrototypeOf(DropList.prototype), '_unstallSkin', this).call(this);
		}
	}, {
		key: '_getCurrentSkinStatus',


		/**
   * 皮肤状态
   * @property {string} unable 不可用
   * @property {string} open 打开状态
   * @property {string} unable-open 不可用且打开
   */
		value: function _getCurrentSkinStatus() {
			var superStatus = _get(DropList.prototype.__proto__ || Object.getPrototypeOf(DropList.prototype), '_getCurrentSkinStatus', this).call(this);
			var result = [];
			if (superStatus) {
				result.push(superStatus);
			}
			if (this.isOpen) {
				result.push('open');
			}
			return result.join('-');
		}
	}, {
		key: 'dropList',


		/**
   * 下拉框
   * @type {List}
   */
		get: function get() {
			return this.findSkinPart('dropList');
		}

		/**
   * @type {Button}
   */

	}, {
		key: 'dropTextInput',
		get: function get() {
			return this.findSkinPart('dropTextInput');
		}

		/**
   * 是否打开状态
   * @type {boolean}
   */

	}, {
		key: 'isOpen',
		get: function get() {
			return this._isOpen;
		},
		set: function set(value) {
			if (this._isOpen !== value) {
				this._isOpen = value;
				this._updateSkinStatus();
				if (this._isOpen) {
					this._updateDropList();
				}
			}
		}

		/**
   * 
   * @type {}
   * @default 
   */

	}, {
		key: 'enable',
		get: function get() {
			return this._enable;
		},
		set: function set(value) {
			if (this._enable !== value) {
				if (this.dropList) {
					this.dropList.enable = value;
				}
				if (this.dropTextInput) {
					this.dropTextInput.enable = value;
				}
				_set(DropList.prototype.__proto__ || Object.getPrototypeOf(DropList.prototype), 'enable', value, this);
			}
		}

		/**
   * 
   * @type {}
   * @default 
   */

	}, {
		key: 'selectedIndex',
		get: function get() {
			return this._selectedIndex;
		},
		set: function set(value) {
			if (this._selectedIndex !== value) {
				this._selectedIndex = value;
				this._updateDropList();
				this._updateLabel();
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
			}
		}

		/**
   * 
   * @type {}
   * @default 
   */

	}, {
		key: 'selectedValue',
		get: function get() {
			if (this._data && this._selectedIndex >= 0) return this._data[this._selectedIndex];
		},
		set: function set(value) {
			if (this._data) {
				var index = this._data.indexOf(value);
				if (index !== this.selectedIndex) this.selectedIndex = index;
			}
		}
	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			if (this._data !== value) {
				this._data = value;
				this._updateDropList();
			}
		}

		/**
  * 
  * @type {}
  * @default 
  */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_RemoteEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}

		/**
   * 根据data生成显示文字的方法。
   * 此方法格式为func(item, index)， item是数据，index是数据所在的位置
   * 生成显示文字有三种方法，优先级为：显式设置label属性 > labelFunction(data) > data.toString()
   * 
   * @type {function}
   */

	}, {
		key: 'labelFunction',
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this._updateDropList();
				this._updateLabel();
			}
		}

		/**
   * 
   * @type {}
   * @default 
   */

	}, {
		key: 'placeholder',
		get: function get() {
			return this._placeholder;
		},
		set: function set(value) {
			if (this._placeholder !== value) {
				this._placeholder = value;
				if (this.dropTextInput) {
					this.dropTextInput.placeholder = value;
				}
			}
		}

		/**
   * 搜索函数。用于比较数据项和关键词是否匹配
   * 格式为fun(item, key): boolean
   * 
   * 默认匹配方法为：查找item的所有属性值和item.toString()，如果其中有一项包含key值，则认为匹配
   */

	}, {
		key: 'searchFunction',
		get: function get() {
			return this._searchFunction;
		},
		set: function set(value) {
			if (this._searchFunction !== value) {
				this._searchFunction = value;
			}
		}

		/**
   * 添加新数据项的方法，格式为fun(text):object
   * text为输入的内容，返回值为要添加的新项；如果返回值为Null,表示不添加
   * 此属性为空表示把text做为新数据项添加
   */

	}, {
		key: 'newValueFunction',
		get: function get() {
			return this._newValueFunction;
		},
		set: function set(value) {
			if (this._newValueFunction !== value) {
				this._newValueFunction = value;
			}
		}

		/**
   * 是否可搜索
   */

	}, {
		key: 'searchAble',
		get: function get() {
			return this._searchAble;
		},
		set: function set(value) {
			if (this._searchAble !== value) {
				this._searchAble = value;
				this.dropTextInput.editable = this._searchAble || this._inputAble;
			}
		}
	}, {
		key: 'inputAble',
		get: function get() {
			return this._inputAble;
		},
		set: function set(value) {
			if (this._inputAble !== value) {
				this._inputAble = value;
				this.dropTextInput.editable = this._searchAble || this._inputAble;
			}
		}
	}]);

	return DropList;
}(_SkinableComponent3.default);

exports.default = DropList;
//# sourceMappingURL=DropList.js.map