'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _SliderBase2 = require('./supports/SliderBase');

var _SliderBase3 = _interopRequireDefault(_SliderBase2);

var _SliderUtil = require('./supports/SliderUtil');

var _SliderUtil2 = _interopRequireDefault(_SliderUtil);

var _Point = require('../core/Point');

var _Point2 = _interopRequireDefault(_Point);

var _HSliderSkin = require('../skins/HSliderSkin');

var _HSliderSkin2 = _interopRequireDefault(_HSliderSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 水平滑块，使用 HSlider（水平滑块）控件，用户可通过在滑块轨道的端点之间移动滑块来选择值。
 * 可设置最大值和最小值，以确保选择的值的范围
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/9 下午2:42:57
 * 
 * @extends SliderBase
 */
var HSlider = function (_SliderBase) {
	_inherits(HSlider, _SliderBase);

	function HSlider() {
		_classCallCheck(this, HSlider);

		return _possibleConstructorReturn(this, (HSlider.__proto__ || Object.getPrototypeOf(HSlider)).apply(this, arguments));
	}

	_createClass(HSlider, [{
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _HSliderSkin2.default;
		}
	}, {
		key: '_pointToValue',
		value: function _pointToValue(point) {
			if (this.track && this.thumb) {
				return _SliderUtil2.default.pointToValue(point.x, this._minValue, this._maxValue, this._stepSize, this.track.offsetWidth, this.thumb.offsetWidth);
			} else {
				throw new Error('皮肤类中未包含track或thumb');
			}
		}
	}, {
		key: '_valueToPoint',
		value: function _valueToPoint() {
			if (this.track && this.thumb) {
				var result = new _Point2.default();
				result.y = this.thumb.offsetTop;
				result.x = _SliderUtil2.default.valueToPosition(this._value, this._minValue, this._maxValue, this.track.offsetWidth, this.thumb.offsetWidth);
				return result;
			} else {
				throw new Error('皮肤类中未包含track或thumb');
			}
		}
	}]);

	return HSlider;
}(_SliderBase3.default);

exports.default = HSlider;
//# sourceMappingURL=HSlider.js.map