'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _MenuItemRender = require('./MenuItemRender');

var _MenuItemRender2 = _interopRequireDefault(_MenuItemRender);

var _TreeBase2 = require('./supports/TreeBase');

var _TreeBase3 = _interopRequireDefault(_TreeBase2);

var _MenuSkin = require('../skins/MenuSkin');

var _MenuSkin2 = _interopRequireDefault(_MenuSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 菜单组件
 * Menu 控件创建可分别选择的选项的弹出菜单，此弹出菜单类似于大多数软件应用程序中的“文件”或“编辑”菜单。弹出菜单可以具有所需的任何数目的子菜单级别
 * 
 * @example <caption>创建菜单</caption>
 * let menuData = [new TreeNodeData('首页'), new TreeNodeData('发现'), new TreeNodeData('话题')];
 * menuData[0].selected = true;
 * <Menu data={this.state.menuData} changeHandler={(event) => {
 *   console.log(event.data);
 * }} />
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-30 13:56:08
 * 
 * @extends TreeBase
 */
var Menu = function (_TreeBase) {
  _inherits(Menu, _TreeBase);

  function Menu() {
    _classCallCheck(this, Menu);

    return _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).apply(this, arguments));
  }

  _createClass(Menu, [{
    key: '_getDefaultSKinClass',
    value: function _getDefaultSKinClass() {
      return _MenuSkin2.default;
    }
  }, {
    key: '_itemClassType',
    get: function get() {
      return _MenuItemRender2.default;
    }
  }]);

  return Menu;
}(_TreeBase3.default);

exports.default = Menu;
//# sourceMappingURL=Menu.js.map