'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _set = function set(object, property, value, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent !== null) { set(parent, property, value, receiver); } } else if ("value" in desc && desc.writable) { desc.value = value; } else { var setter = desc.set; if (setter !== undefined) { setter.call(receiver, value); } } return value; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('./SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _NumberUtil = require('../utils/NumberUtil');

var _NumberUtil2 = _interopRequireDefault(_NumberUtil);

var _NumberSteperSkin = require('../skins/NumberSteperSkin');

var _NumberSteperSkin2 = _interopRequireDefault(_NumberSteperSkin);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _RemoteEvent = require('../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 步进组件，允许用户从有序集中选择值，包括一个单行输入文本字段和一对用于逐一显示可能值的箭头按钮。
 * 还可使用向上箭头键和向下箭头键遍历这些值
 * 
 * refs
 * <ol>
 * 	<li>upButton  值增加的按钮  推荐类型:{@link Button}</li>
 *  <li>downButton 值减少的按钮  推荐类型:{@link Button}</li>
 * 	<li>inputNode 输入框 类型:{@link TextInput} </li>
 * </ol>
 * 
 * @extends SkinableComponent
 * @date   : 2017-9-18 09:31:40
 */
var NumberSteper = function (_SkinableComponent) {
	_inherits(NumberSteper, _SkinableComponent);

	function NumberSteper() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, NumberSteper);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = NumberSteper.__proto__ || Object.getPrototypeOf(NumberSteper)).call.apply(_ref, [this].concat(args))), _this), _this._upButtonClickHandler = function (event) {
			_this.value += _this.stepSize;
		}, _this._downButtonClickHandler = function (event) {
			_this.value -= _this.stepSize;
		}, _this._inputTextChangeHandler = function (event) {

			var number = Number(event.currentTarget.text);
			if (isNaN(number)) {
				_this.inputText.text = _this.value;
			} else if (_this.value !== number) {
				_this.value = number;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(NumberSteper, [{
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(NumberSteper.prototype.__proto__ || Object.getPrototypeOf(NumberSteper.prototype), '_initProperty', this).call(this);
			this._value = 0;
			this._stepSize = 1;
			this._minValue = 0;
			this._maxValue = 100;
		}
	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _NumberSteperSkin2.default;
		}

		/**
   * 步进值，必须大于0，如果设置小于0的值，将被设置为1
   */

	}, {
		key: '_initSkin',


		/**
   * @inheritdoc
   */
		value: function _initSkin() {
			_get(NumberSteper.prototype.__proto__ || Object.getPrototypeOf(NumberSteper.prototype), '_initSkin', this).call(this);
			this._updateChildrenEnable();
			if (this.upButton != null) {
				if (this.upButton instanceof _Button2.default) {
					this.upButton.autoRepeatClick = true;
				}
				var eventTarget = this.upButton instanceof _Button2.default ? this.upButton.rootComponent : this.upButton;
				eventTarget.addEventListener('click', this._upButtonClickHandler);
			}
			if (this.downButton != null) {
				if (this.downButton instanceof _Button2.default) {
					this.downButton.autoRepeatClick = true;
				}
				var _eventTarget = this.downButton instanceof _Button2.default ? this.downButton.rootComponent : this.downButton;
				_eventTarget.addEventListener('click', this._downButtonClickHandler);
			}
			if (this.inputText) {
				this.inputText.addEventListener(_RemoteEvent2.default.BLUR, this._inputTextChangeHandler);

				this.inputText.text = this._value.toString();
				this.inputText.restrict = '0-9.-';
			}
		}

		/**
   * 
   * @type {}
   * @default 
   */

	}, {
		key: '_updateChildrenEnable',
		value: function _updateChildrenEnable() {
			if (this.upButton) {
				this.upButton.enable = this.enable;
			}
			if (this.downButton) {
				this.downButton.enable = this.enable;
			}
			if (this.inputText) {
				this.inputText.enable = this.enable;
			}
		}

		/**
   * @private
   */


		/**
   * @private
   */


		/**
   * @private
   */

	}, {
		key: 'stepSize',
		get: function get() {
			return this._stepSize;
		},
		set: function set(value) {
			if (value <= 0) {
				value = 1;
			}
			this._stepSize = value;
		}

		/**
   * 当前值
   */

	}, {
		key: 'value',
		get: function get() {
			return this._value;
		},
		set: function set(v) {
			var effectV = _NumberUtil2.default.limit(v, this._minValue, this._maxValue);
			if (effectV !== this._value) {
				this._value = effectV;
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
			}
			if (this.inputText) {
				this.inputText.text = this._value.toString();
			}
		}

		/**
   * 允许的最小值
   * @type {number}
   */

	}, {
		key: 'minValue',
		get: function get() {
			return this._minValue;
		},
		set: function set(value) {
			this._minValue = value;
			this.value = _NumberUtil2.default.limit(this.value, this._minValue, this._maxValue);
		}

		/**
   * 允许的最大值
   * @type {number}
   */

	}, {
		key: 'maxValue',
		get: function get() {
			return this._maxValue;
		},
		set: function set(value) {
			this._maxValue = value;
			this.value = _NumberUtil2.default.limit(this.value, this._minValue, this._maxValue);
		}
	}, {
		key: 'upButton',
		get: function get() {
			return this.findSkinPart('upButton');
		}
	}, {
		key: 'downButton',
		get: function get() {
			return this.findSkinPart('downButton');
		}
	}, {
		key: 'inputText',
		get: function get() {
			return this.findSkinPart('inputText');
		}
	}, {
		key: 'enable',
		get: function get() {
			return _get(NumberSteper.prototype.__proto__ || Object.getPrototypeOf(NumberSteper.prototype), 'enable', this);
		},
		set: function set(value) {
			if (this._enable !== value) {
				_set(NumberSteper.prototype.__proto__ || Object.getPrototypeOf(NumberSteper.prototype), 'enable', value, this);
				this._updateChildrenEnable();
			}
		}
	}]);

	return NumberSteper;
}(_SkinableComponent3.default);

exports.default = NumberSteper;
//# sourceMappingURL=NumberSteper.js.map