'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _ListBase2 = require('./supports/ListBase');

var _ListBase3 = _interopRequireDefault(_ListBase2);

var _PickItem = require('./PickItem');

var _PickItem2 = _interopRequireDefault(_PickItem);

var _SystemUtil = require('../utils/SystemUtil');

var _SystemUtil2 = _interopRequireDefault(_SystemUtil);

var _HtmlUtil = require('../utils/HtmlUtil');

var _HtmlUtil2 = _interopRequireDefault(_HtmlUtil);

var _NumberUtil = require('../utils/NumberUtil');

var _NumberUtil2 = _interopRequireDefault(_NumberUtil);

var _Point = require('../core/Point');

var _Point2 = _interopRequireDefault(_Point);

var _PickerSkin = require('../skins/PickerSkin');

var _PickerSkin2 = _interopRequireDefault(_PickerSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Picker控件包含多个选项，可通过滑动的方式选择其中一项
 * 
 * @date   : 2017-9-19 13:40:44
 * 
 * @extends ListBase
 */
var Picker = function (_ListBase) {
	_inherits(Picker, _ListBase);

	function Picker() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Picker);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Picker.__proto__ || Object.getPrototypeOf(Picker)).call.apply(_ref, [this].concat(args))), _this), _this._mouseDownHandler = function (event) {
			if (_this.enable) {
				_this._startMousePoint = _HtmlUtil2.default.getMouseEventPosition(event);
				_this._startPosition = new _Point2.default(_this.container.offsetLeft, _this.container.offsetTop);
				var mouseEvents = ['mouseup', 'mousemove'];
				var touchEvents = ['touchend', 'touchmove'];

				var useEvents = _SystemUtil2.default.isMobile() ? touchEvents : mouseEvents;
				useEvents.forEach(function (value) {
					document.addEventListener(value, _this._mouseEventHandler);
				}, _this);
			}
		}, _this._mouseEventHandler = function (event) {
			switch (event.type) {
				case 'mouseup':
				case 'touchend':
					{
						var mouseEvents = ['mouseup', 'mousemove'];
						var touchEvents = ['touchend', 'touchmove'];

						var useEvents = _SystemUtil2.default.isMobile() ? touchEvents : mouseEvents;
						useEvents.forEach(function (value) {
							document.removeEventListener(value, _this._mouseEventHandler);
						}, _this);

						//根据位置，设置距离最近的选中项
						var point = _HtmlUtil2.default.getMouseEventPosition(event);
						if (point != null) {
							var y = _this._startPosition.y + point.y - _this._startMousePoint.y;
							_this.selectedIndex = _this._positionToValueIndex(y);
						}
						break;
					}
				case 'mousemove':
				case 'touchmove':
					{
						var _point = _HtmlUtil2.default.getMouseEventPosition(event);
						if (_point != null) {
							var _y = _this._startPosition.y + _point.y - _this._startMousePoint.y;

							//内容随鼠标滚动,但是不超出第0项和最后一项的范围
							var y0 = _this._valueToPosition(0);
							var yMax = _this._valueToPosition(_this._children.length - 1);
							_this._setContainerPosition(_NumberUtil2.default.limit(_y, yMax, y0));
						}
						break;
					}
				default:
					{}
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Picker, [{
		key: '_createItemProps',
		value: function _createItemProps(data, index) {
			var result = _get(Picker.prototype.__proto__ || Object.getPrototypeOf(Picker.prototype), '_createItemProps', this).call(this, data, index);
			result.style = { height: this._itemHeight + 'px' };
			return result;
		}
	}, {
		key: '_initProperty',
		value: function _initProperty() {
			_get(Picker.prototype.__proto__ || Object.getPrototypeOf(Picker.prototype), '_initProperty', this).call(this);
			this._itemHeight = 30;
			this._displayItemNumber = 5;
			this._selectedIndex = 0;
			this._startMousePoint = null;
			this._startPosition = null;
			this.itemClassType = _PickItem2.default;
		}

		/**
   * 显示的子项数量
   */

	}, {
		key: '_initSkin',


		/**
   * @inheritdoc
   */
		value: function _initSkin() {
			var _this2 = this;

			_get(Picker.prototype.__proto__ || Object.getPrototypeOf(Picker.prototype), '_initSkin', this).call(this);

			if (this.container) {
				this.container.style.width = '100%';
				this.container.style.position = 'absolute';
				this.container.style.height = '';

				var mouseEvents = ['mousedown'];
				var touchEvents = ['touchstart'];

				var useEvents = _SystemUtil2.default.isMobile() ? touchEvents : mouseEvents;
				useEvents.forEach(function (value) {
					return _this2.rootComponent.addEventListener(value, _this2._mouseDownHandler.bind(_this2));
				}, this);
				this._setContainerPosition(this._valueToPosition(this._selectedIndex));
			}
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_setContainerPosition',


		/**
   * @private
   */
		value: function _setContainerPosition(y) {
			if (this.container) {
				this.container.style.top = y + 'px';
			}
		}

		/**
   * @private
   */


		/**
   * @private
   */

	}, {
		key: '_valueToPosition',


		/**
   * 获取当选中第index项时，container的top值
   * @param {Number} index 选中项序号 
   * 
   * @private
   */
		value: function _valueToPosition(index) {
			var y = this._itemHeight * this._displayItemNumber / 2 - (index * this._itemHeight + 0.5 * this._itemHeight);
			return y;
		}

		/**
   * 当container的top值为y时，对应的选中项
   * @param {Number} y top值 
   */

	}, {
		key: '_positionToValueIndex',
		value: function _positionToValueIndex(y) {
			var result = Math.round((this._itemHeight * this._displayItemNumber / 2 - y - 0.5 * this._itemHeight) / this._itemHeight);
			return _NumberUtil2.default.limit(result, 0, this._children.length - 1);
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_getDefaultStyle',
		value: function _getDefaultStyle() {
			var height = this._displayItemNumber * this._itemHeight + 'px';
			return {
				position: 'relative',
				overflow: 'hidden',
				height: height,
				minWidth: '100px'
			};
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _PickerSkin2.default;
		}
	}, {
		key: 'displayItemNumber',
		get: function get() {
			return this._displayItemNumber;
		},
		set: function set(value) {
			if (this._displayItemNumber !== value) {
				this._displayItemNumber = value;
				this.forceUpdate();
			}
		}

		/**
   * 子项高度,单位：像素
   * @type {number}
   * @default 30
   */

	}, {
		key: 'itemHeight',
		get: function get() {
			return this._itemHeight;
		},
		set: function set(value) {
			if (this._itemHeight !== value) {
				this._itemHeight = value;
				this.forceUpdate();
			}
		}

		/**
   * skinPart 子项容器
   */

	}, {
		key: 'container',
		get: function get() {
			return this.findSkinPart('container');
		}
	}, {
		key: 'selectedIndex',
		set: function set(value) {
			if (this._children === null || this._children.length === 0) return;

			if (this.selectedIndex !== value) {
				this._selectedIndex = value;
				this._setContainerPosition(this._valueToPosition(value));
			}
		}
	}]);

	return Picker;
}(_ListBase3.default);

exports.default = Picker;
//# sourceMappingURL=Picker.js.map