'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('./SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _ProgressBarSkin = require('../skins/ProgressBarSkin');

var _ProgressBarSkin2 = _interopRequireDefault(_ProgressBarSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 进度条
 * @author: xujunjie 
 * @Date: 2017-09-28 11:24:29 
 * @Last Modified time: 2017-09-28 11:24:29 
 * 
 * @example 
 * componentDidMount() {
 *  setInterval(() => {
 *    if (this.refs.pb.value >= this.refs.pb.maxValue) {
 *       this.refs.pb.value = 0;
 *     } else {
 *       this.refs.pb.value += 10;
 *     }
 *   }, 500);
 * }
 *
 * pbLabelFun(value, maxValue){
 *   return value + '/' + maxValue;
 * }
 * 
 * <ProgressBar ref='pb' value={50.6} maxValue={100} labelFunction={this.pbLabelFun} />
 * 
 * @extends SkinableComponent
 */
var ProgressBar = function (_SkinableComponent) {
  _inherits(ProgressBar, _SkinableComponent);

  function ProgressBar() {
    _classCallCheck(this, ProgressBar);

    return _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).apply(this, arguments));
  }

  _createClass(ProgressBar, [{
    key: '_initProperty',


    /**
     * @inheritdoc
     */
    value: function _initProperty() {
      _get(ProgressBar.prototype.__proto__ || Object.getPrototypeOf(ProgressBar.prototype), '_initProperty', this).call(this);
      this._value = 0;
      this._maxValue = 100;
      this._labelFunction = null;
    }

    /**
     * 进度值转换为文本的函数，格式为fun(value, maxValue)
     * 如果为null，则使用系统默认转换函数
     * @property {number} value 当前进度值
     * @property {number} maxValue 最大进度值
     * 
     * @type {function}
     * 
     * @default null
     */

  }, {
    key: '_getDefaultSKinClass',


    /**
     * @inheritdoc
     */
    value: function _getDefaultSKinClass() {
      return _ProgressBarSkin2.default;
    }

    /**
     * 设置进度信息和最大进度值
     * 
     * @param {number} value 进度值
     * @param {number} maxValue 最大进度值
     * @memberof ProgressBar
     */

  }, {
    key: 'setProgress',
    value: function setProgress(value, maxValue) {
      this._value = value;
      this._maxValue = maxValue;
      this.forceUpdate();
    }

    /**
     * 当前进度值，此值范围应在[0, maxValue]之间，如果超出此区间，会被设置到此区间内
     * 
     * @type {number}
     * 
     * @memberof ProgressBar
     */

  }, {
    key: '_adpteValue',
    value: function _adpteValue() {
      if (this._value < 0) {
        this._value = 0;
      }
      if (this._value > this._maxValue) {
        this._value = this._maxValue;
      }
    }
  }, {
    key: 'label',
    get: function get() {
      if (this._labelFunction) {
        return this._labelFunction(this.value, this.maxValue);
      }
      return Math.round(this.value * 100 / this.maxValue) + '%';
    }
  }, {
    key: 'labelFunction',
    get: function get() {
      return this._labelFunction;
    },
    set: function set(value) {
      if (this._labelFunction !== value) {
        this._labelFunction = value;
        this.forceUpdate();
      }
    }
  }, {
    key: 'value',
    get: function get() {
      return this._value;
    },
    set: function set(v) {
      if (this._value !== v) {
        this._value = v;
        this._adpteValue();
        this.forceUpdate();
      }
    }

    /**
     * 最大值
     * @type {number}
     * @memberof ProgressBar
     */

  }, {
    key: 'maxValue',
    get: function get() {
      return this._maxValue;
    },
    set: function set(value) {
      if (this._maxValue !== value) {
        this._maxValue = value;
        this._adpteValue();
        this.forceUpdate();
      }
    }
  }]);

  return ProgressBar;
}(_SkinableComponent3.default);

exports.default = ProgressBar;
//# sourceMappingURL=ProgressBar.js.map