'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _ToggleButtonBase2 = require('./supports/ToggleButtonBase');

var _ToggleButtonBase3 = _interopRequireDefault(_ToggleButtonBase2);

var _RadioButtonSkin = require('../skins/RadioButtonSkin');

var _RadioButtonSkin2 = _interopRequireDefault(_RadioButtonSkin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * RadioButton 组件使用户可在一组互相排斥的选择中做出一种选择。
 * RadioButtonGroup 包含两个或更多 RadioButton 组件，当选中一个时，其它的RadioButton会自动取消选中
 * 
 * 通常需要配合{@link RadioButtonGroup}使用
 * 
 * @extends ToggleButtonBase
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/5 下午1:06:06
 */
var RadioButton = function (_ToggleButtonBase) {
  _inherits(RadioButton, _ToggleButtonBase);

  function RadioButton() {
    _classCallCheck(this, RadioButton);

    return _possibleConstructorReturn(this, (RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).apply(this, arguments));
  }

  _createClass(RadioButton, [{
    key: '_initProperty',


    /**
    * @inheritdoc
    */
    value: function _initProperty() {
      _get(RadioButton.prototype.__proto__ || Object.getPrototypeOf(RadioButton.prototype), '_initProperty', this).call(this);
      this._value = null;
      this._selectedAble = true;
      this._group = null;
    }
  }, {
    key: 'clickHandler',


    /**
    * @inheritdoc
    */
    value: function clickHandler(event) {
      _get(RadioButton.prototype.__proto__ || Object.getPrototypeOf(RadioButton.prototype), 'clickHandler', this).call(this, event);
      if (this.enable && this.selected !== true) this.selected = true;
    }

    /**
    * @inheritdoc
    */

  }, {
    key: '_getDefaultSKinClass',
    value: function _getDefaultSKinClass() {
      return _RadioButtonSkin2.default;
    }
  }, {
    key: 'group',
    get: function get() {
      return this._group;
    },
    set: function set(value) {
      if (this._group !== value) {
        if (this._group) this._group.removeItem(this);
        this._group = value;
        if (this._group) {
          this._group.addItem(this);
        }
      }
    }

    /**
     * 携带的数据
     * @type {*}
     */

  }, {
    key: 'value',
    get: function get() {
      return this._value;
    },
    set: function set(value) {
      this._value = value;
      this.forceUpdate();
    }
  }]);

  return RadioButton;
}(_ToggleButtonBase3.default);

exports.default = RadioButton;
//# sourceMappingURL=RadioButton.js.map