'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Collection2 = require('../core/Collection');

var _Collection3 = _interopRequireDefault(_Collection2);

var _RemoteEvent = require('../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

var _DataEvent = require('../events/DataEvent');

var _DataEvent2 = _interopRequireDefault(_DataEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 单选按钮组
 * @author xujunjie
 * @mail yinhunfeixue@163.com
 * @date 2017-11-28 08:57:20
 */
var RadioButtonGroup = function (_Collection) {
	_inherits(RadioButtonGroup, _Collection);

	function RadioButtonGroup() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RadioButtonGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RadioButtonGroup.__proto__ || Object.getPrototypeOf(RadioButtonGroup)).call.apply(_ref, [this].concat(args))), _this), _this.item_changeHandler = function (event) {
			//有一项被选中，则取消其它所有项的选中
			var target = event.currentTarget;
			if (target.selected) {
				_this.selectedValue = target.value;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(RadioButtonGroup, [{
		key: 'addItemAt',
		value: function addItemAt(item, index) {
			_get(RadioButtonGroup.prototype.__proto__ || Object.getPrototypeOf(RadioButtonGroup.prototype), 'addItemAt', this).call(this, item, index);
			item.addEventListener(_RemoteEvent2.default.CHANGE, this.item_changeHandler);
		}
	}, {
		key: 'removeItemAt',
		value: function removeItemAt(index) {
			var item = _get(RadioButtonGroup.prototype.__proto__ || Object.getPrototypeOf(RadioButtonGroup.prototype), 'removeItemAt', this).call(this, index);
			if (item) {
				item.removeEventListener(_RemoteEvent2.default.CHANGE, this.item_changeHandler);
			}
		}
	}, {
		key: 'removeItem',
		value: function removeItem(item) {
			if (item) {
				item.removeEventListener(_RemoteEvent2.default.CHANGE, this.item_changeHandler);
			}
			_get(RadioButtonGroup.prototype.__proto__ || Object.getPrototypeOf(RadioButtonGroup.prototype), 'removeItem', this).call(this, item);
		}
	}, {
		key: 'unSelected',
		value: function unSelected() {
			if (this._data && this._data.length > 0) {
				for (var i = 0; i < this._data.length; i++) {
					var item = this._data[i];
					item.selected = false;
				}
			}
		}
	}, {
		key: 'selectedValue',


		/**
   * 当前选中的值列表
   * 设置为Null,表示不选中任何项
   * @type {Array}
   */
		get: function get() {
			var result = [];
			if (this._data && this._data.length > 0) {
				for (var i = 0; i < this._data.length; i++) {
					var item = this._data[i];
					if (item.selected) {
						return item.value;
					}
				}
			}
			return result;
		},
		set: function set(value) {
			if (this._data && this._data.length > 0) {
				var selectedValue = null;
				for (var i = 0; i < this._data.length; i++) {
					var item = this._data[i];
					if (item.value === value) {
						item.selected = true;
						selectedValue = item.value;
					} else {
						item.selected = false;
					}
				}
				if (selectedValue) {
					this.dispatchEvent(new _DataEvent2.default(_DataEvent2.default.DATA_CHANGED, selectedValue));
				}
			}
		}
	}]);

	return RadioButtonGroup;
}(_Collection3.default);

exports.default = RadioButtonGroup;
//# sourceMappingURL=RadioButtonGroup.js.map