'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _UIComponent2 = require('./UIComponent');

var _UIComponent3 = _interopRequireDefault(_UIComponent2);

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TableHeaderItemRender = require('./TableHeaderItemRender');

var _TableHeaderItemRender2 = _interopRequireDefault(_TableHeaderItemRender);

require('../skins/less/Table.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * 表格，通过设置列属性和数据，可自动展示数据
 * 
 * @author: xujunjie 
 * @Date: 2017-09-28 16:31:16 
 * @Last Modified time: 2017-10-10 12:39:21
 */
var Table = function (_UIComponent) {
	_inherits(Table, _UIComponent);

	function Table() {
		_classCallCheck(this, Table);

		return _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).apply(this, arguments));
	}

	_createClass(Table, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(Table.prototype.__proto__ || Object.getPrototypeOf(Table.prototype), '_initProperty', this).call(this);
			this._columns = [];
			this._data = [];
		}
	}, {
		key: 'addRow',
		value: function addRow(rowData) {}
	}, {
		key: 'subRow',
		value: function subRow(rowIndex) {}
	}, {
		key: 'addCol',
		value: function addCol(column) {}
	}, {
		key: 'subCol',
		value: function subCol(column) {}
	}, {
		key: '_renderHeader',
		value: function _renderHeader() {
			var _this2 = this;

			var elements = [];
			if (this._columns) {
				elements = this._columns.map(function (value, index, array) {
					var props = {
						rowIndex: _this2.index,
						data: value,
						column: value
					};

					var type = value.headerRender ? value.headerRender : _TableHeaderItemRender2.default;
					return _react2.default.createElement(
						'td',
						{ key: index },
						_react2.default.createElement(type, props)
					);
				});
			}
			return elements;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var elements = [];
			if (this._data) {
				elements = this._data.map(function (value, index, array) {
					return _react2.default.createElement(_TableRow2.default, { data: value, columns: _this3._columns, index: index, key: index });
				});
			}
			return _react2.default.createElement(
				'table',
				{ className: 'table ' + this.props.className, cellPadding: '0', cellSpacing: '0' },
				_react2.default.createElement(
					'thead',
					null,
					_react2.default.createElement(
						'tr',
						null,
						this._renderHeader()
					)
				),
				_react2.default.createElement(
					'tbody',
					null,
					elements
				)
			);
		}
	}, {
		key: 'columns',
		get: function get() {
			return this._columns;
		},
		set: function set(value) {
			if (this._columns !== value) {
				this._columns = value;
				//设置序号
				if (this._columns) {
					this._columns.forEach(function (value, index, array) {
						value.index = index;
					}, this);
				}
				this.forceUpdate();
			}
		}
	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			if (this._data !== value) {
				this._data = value;
				this.forceUpdate();
			}
		}
	}]);

	return Table;
}(_UIComponent3.default);

exports.default = Table;
//# sourceMappingURL=Table.js.map