'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _UIComponent2 = require('./UIComponent');

var _UIComponent3 = _interopRequireDefault(_UIComponent2);

var _TableCellItemRender = require('./TableCellItemRender');

var _TableCellItemRender2 = _interopRequireDefault(_TableCellItemRender);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 表示表格中的一行
 * @author xujunjie
 * @mail yinhunfeixue@163.com
 * @date 2017-10-10 09:36:49
 */
var TableRow = function (_UIComponent) {
	_inherits(TableRow, _UIComponent);

	function TableRow() {
		_classCallCheck(this, TableRow);

		return _possibleConstructorReturn(this, (TableRow.__proto__ || Object.getPrototypeOf(TableRow)).apply(this, arguments));
	}

	_createClass(TableRow, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(TableRow.prototype.__proto__ || Object.getPrototypeOf(TableRow.prototype), '_initProperty', this).call(this);
			this._data = null;
			this._columns = null;
			this._index = 0;
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var elements = [];
			if (this._data && this._columns) {
				elements = this._columns.map(function (value, index, array) {
					var props = {
						rowIndex: _this2.index,
						data: _this2.data,
						column: value,
						owner: _this2
					};
					var type = value.itemRender ? value.itemRender : _TableCellItemRender2.default;
					return _react2.default.createElement(
						'td',
						{ key: index },
						_react2.default.createElement(type, props)
					);
				});
			}
			return _react2.default.createElement(
				'tr',
				null,
				elements
			);
		}
	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			if (this._data !== value) {
				this._data = value;
				this.forceUpdate();
			}
		}
	}, {
		key: 'columns',
		get: function get() {
			return this._columns;
		},
		set: function set(value) {
			if (this._columns !== value) {
				this._columns = value;
				this.forceUpdate();
			}
		}
	}, {
		key: 'index',
		get: function get() {
			return this._index;
		},
		set: function set(value) {
			if (this._index !== value) {
				this._index = value;
				this.forceUpdate();
			}
		}
	}]);

	return TableRow;
}(_UIComponent3.default);

exports.default = TableRow;
//# sourceMappingURL=TableRow.js.map