'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('./SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _TitleWindowSkin = require('../skins/TitleWindowSkin');

var _TitleWindowSkin2 = _interopRequireDefault(_TitleWindowSkin);

var _DataEvent = require('../events/DataEvent');

var _DataEvent2 = _interopRequireDefault(_DataEvent);

var _Drager = require('../core/Drager');

var _Drager2 = _interopRequireDefault(_Drager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 带标题栏的窗口
 * 
 * <h3>皮肤部件</h3>
 * <ol>
 * 	<li>contentContainer  内容容器</li>
 *  <li>buttonContainer   标题档按钮容器</li>
 *  <li>titleLabel  显示标题文字的元素</li>
 * 	<li>moveArea 可响应拖动窗口的对象</li>
 * <ol>
 * 
 * @date:2017-9-22 08:57:18
 * 
 * @extends SkinableComponent
 */
var TitleWindow = function (_SkinableComponent) {
	_inherits(TitleWindow, _SkinableComponent);

	function TitleWindow() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TitleWindow);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TitleWindow.__proto__ || Object.getPrototypeOf(TitleWindow)).call.apply(_ref, [this].concat(args))), _this), _this._maxButtonClickHandler = function (event) {
			if (_this._sizeState === TitleWindow.SIZE_MAX) {
				_this.normal();
			} else {
				_this.max();
			}
		}, _this._minButtonClickHandler = function (event) {
			if (_this._sizeState === TitleWindow.SIZE_MIN) {
				_this.normal();
			} else {
				_this.min();
			}
		}, _this._closeButtonClickHandler = function (event) {
			_this.dispatchEvent(new _DataEvent2.default(_DataEvent2.default.CLOSE, null));
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	/**
  * @enum {int} 表示正常尺寸
  * 
  */


	/**
  * @enum {int} 表示窗口最大化
  */


	/**
  * @enum {int} 表示窗口最小化
  */


	_createClass(TitleWindow, [{
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(TitleWindow.prototype.__proto__ || Object.getPrototypeOf(TitleWindow.prototype), '_initProperty', this).call(this);
			this._titleText = 'windowTitle';
			this._minEnable = true;
			this._closeEnable = true;
			this._maxEnable = true;
			this._closeButtonSkin = null;
			this._minButtonSkin = null;
			this._maxButtonSkin = null;
			this._closeHandler = null;
			this._dragEnable = false;
			this._beforeDragPositon = null;
			this._drager = new _Drager2.default();

			this._sizeState = TitleWindow.SIZE_NORMAL;
		}

		/**
   * 设置是否可拖动
   * 如果允许拖动，窗口的position将被设置成absolute
   * @type {boolean}
   * @default false
   */

	}, {
		key: '_updateDrager',


		/**
   * @private
   */
		value: function _updateDrager() {
			if (this._dragEnable) {
				if (this.moveArea && this.container) {
					if (this._beforeDragPositon === null) {
						this._beforeDragPositon = this.container.style.position;
					}
					this.moveArea.style.cursor = 'move';
					this.container.style.position = 'absolute';
					this._drager.bind(this.moveArea, this.container);
				}
			} else {
				if (this.container) {
					this.container.style.position = this._beforeDragPositon;
				}
				if (this.moveArea) {
					this.moveArea.style.cursor = '';
				}
				this._drager.unbind();
			}
		}
		/**
   * 窗口关闭时执行的函数
   * 事件类型{@link DataEvent#CLOSE}，可根据事件携带的数据判断点击的按钮
   * @type {function}
   * 
   * @default null
   */

	}, {
		key: '_getDefaultSKinClass',


		/**
   * @inheritdoc
   */
		value: function _getDefaultSKinClass() {
			return _TitleWindowSkin2.default;
		}

		/**
   * @private
   */

	}, {
		key: '_initSkin',


		/**
   * @inheritdoc
   */
		value: function _initSkin() {
			_get(TitleWindow.prototype.__proto__ || Object.getPrototypeOf(TitleWindow.prototype), '_initSkin', this).call(this);

			this._renderTitle();
			this._renderButtons();
			this._renderContent();
			this._updateDrager();
		}

		/**
   * @private
   */

	}, {
		key: '_renderTitle',
		value: function _renderTitle() {
			if (this.titleLabel) {
				this.titleLabel.innerHTML = this._titleText;
			}
		}

		/**
   * @private
   */

	}, {
		key: '_renderContent',
		value: function _renderContent() {
			if (this.contentContainer && this.props.children) {
				_reactDom2.default.render(this.props.children, this.contentContainer);
			}
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_getCurrentSkinStatus',
		value: function _getCurrentSkinStatus() {
			var parentStatus = _get(TitleWindow.prototype.__proto__ || Object.getPrototypeOf(TitleWindow.prototype), '_getCurrentSkinStatus', this).call(this);

			var result = [];
			if (parentStatus) result.push(parentStatus);

			switch (this._sizeState) {
				case TitleWindow.SIZE_MAX:
					result.push('max');
					break;
				case TitleWindow.SIZE_MIN:
					result.push('min');
					break;
				default:
					break;
			}
			return result.join('-');
		}

		/**
   * @private
   */

	}, {
		key: '_renderButtons',
		value: function _renderButtons() {
			if (this.buttonMin) {
				this.buttonMin.style.display = this._minEnable ? '' : 'none';
				this.buttonMin.rootComponent.onclick = this._minButtonClickHandler;
			}
			if (this.buttonMax) {
				this.buttonMax.style.display = this._maxEnable ? '' : 'none';
				this.buttonMax.rootComponent.onclick = this._maxButtonClickHandler;
			}
			if (this.buttonClose) {
				this.buttonClose.style.display = this._closeEnable ? '' : 'none';
				this.buttonClose.rootComponent.onclick = this._closeButtonClickHandler;
			}
		}
	}, {
		key: 'max',


		/**
   * 最大化窗口
   */
		value: function max() {
			this._sizeState = TitleWindow.SIZE_MAX;
			this._drager.enable = false;
			this._updateSkinStatus();
		}

		/**
   * 最小化窗口
   */

	}, {
		key: 'min',
		value: function min() {
			this._sizeState = TitleWindow.SIZE_MIN;
			this._drager.enable = true;
			this._updateSkinStatus();
		}

		/**
   * 窗口恢复成普通状态
   */

	}, {
		key: 'normal',
		value: function normal() {
			this._sizeState = TitleWindow.SIZE_NORMAL;
			this._drager.enable = true;
			this._updateSkinStatus();
		}

		/**
   * @private
   */


		/**
   * @private
   */

	}, {
		key: '_unstallSkin',
		value: function _unstallSkin() {
			this._drager.unbind();
			_get(TitleWindow.prototype.__proto__ || Object.getPrototypeOf(TitleWindow.prototype), '_unstallSkin', this).call(this);
		}
	}, {
		key: 'dragEnable',
		get: function get() {
			return this._dragEnable;
		},
		set: function set(value) {
			if (this._dragEnable !== value) {
				this._dragEnable = value;
				this._updateDrager();
			}
		}
	}, {
		key: 'closeHandler',
		get: function get() {
			return this._closeHandler;
		},
		set: function set(value) {
			if (this.closeHandler !== value) {
				this._changeEventListener(_DataEvent2.default.CLOSE, value, this._closeHandler);
				this._closeHandler = value;
			}
		}

		/**
   * 关闭按钮的皮肤类
   * @type {class}
   */

	}, {
		key: 'closeButtonSkin',
		get: function get() {
			return this._closeButtonSkin;
		},
		set: function set(value) {
			if (this._closeButtonSkin !== value) {
				this._closeButtonSkin = value;
				this.forceUpdate();
			}
		}

		/**
   * 最小化按钮的皮肤类
   * @type {class}
   */

	}, {
		key: 'minButtonSkin',
		get: function get() {
			return this._minButtonSkin;
		},
		set: function set(value) {
			if (this._minButtonSkin !== value) {
				this._minButtonSkin = value;
				this.forceUpdate();
			}
		}

		/**
   * 最大化按钮的皮肤类
   * @type {class}
   */

	}, {
		key: 'maxButtonSkin',
		get: function get() {
			return this._maxButtonSkin;
		},
		set: function set(value) {
			if (this._maxButtonSkin !== value) {
				this._maxButtonSkin = value;
				this.forceUpdate();
			}
		}

		/**
   * 是否可最小化
   * @type {boolean}
   */

	}, {
		key: 'minEnable',
		get: function get() {
			return this._minEnable;
		},
		set: function set(value) {
			if (value !== this._minEnable) {
				this._minEnable = value;
				this._renderTitle();
			}
		}

		/**
   * 是否可关闭
   * @type {boolean}
   */

	}, {
		key: 'closeEnable',
		get: function get() {
			return this._closeEnable;
		},
		set: function set(value) {
			if (value !== this._closeEnable) {
				this._closeEnable = value;
				this._renderTitle();
			}
		}

		/**
   * 是否可最大化
   * @type {boolean}
   */

	}, {
		key: 'maxEnable',
		get: function get() {
			return this._maxEnable;
		},
		set: function set(value) {
			if (value !== this._maxEnable) {
				this._maxEnable = value;
				this._renderTitle();
			}
		}

		/**
   * 窗口标题
   * @type {string}
   * 
   * @default 'windowTitle'
   */

	}, {
		key: 'titleText',
		get: function get() {
			return this._titleText;
		},
		set: function set(value) {
			if (this._titleText !== value) {
				this._titleText = value;
				this._renderTitle();
			}
		}
	}, {
		key: 'container',
		get: function get() {
			return this.findSkinPart('container');
		}

		/**
   * 内容容器
   */

	}, {
		key: 'contentContainer',
		get: function get() {
			return this.findSkinPart('contentContainer');
		}

		/**
   * 可响应窗口拖动的对象
   */

	}, {
		key: 'moveArea',
		get: function get() {
			return this.findSkinPart('moveArea');
		}

		/**
   * 显示标题的HTML元素
   * 
   */

	}, {
		key: 'titleLabel',
		get: function get() {
			return this.findSkinPart('titleLabel');
		}

		/**
   * 按钮窗口，用于放置最大化，最小化，关闭等按钮
   */

	}, {
		key: 'buttonContainer',
		get: function get() {
			return this.findSkinPart('buttonContainer');
		}
	}, {
		key: 'buttonMin',
		get: function get() {
			return this.findSkinPart('buttonMin');
		}
	}, {
		key: 'buttonMax',
		get: function get() {
			return this.findSkinPart('buttonMax');
		}
	}, {
		key: 'buttonClose',
		get: function get() {
			return this.findSkinPart('buttonClose');
		}

		/**
   * @private
   */

	}]);

	return TitleWindow;
}(_SkinableComponent3.default);

TitleWindow.SIZE_NORMAL = 1;
TitleWindow.SIZE_MAX = 2;
TitleWindow.SIZE_MIN = 3;
exports.default = TitleWindow;
//# sourceMappingURL=TitleWindow.js.map