'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('./SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _NumberUtil = require('../utils/NumberUtil');

var _NumberUtil2 = _interopRequireDefault(_NumberUtil);

var _ViewStackSkin = require('../skins/ViewStackSkin');

var _ViewStackSkin2 = _interopRequireDefault(_ViewStackSkin);

var _ObjectUtil = require('../utils/ObjectUtil');

var _ObjectUtil2 = _interopRequireDefault(_ObjectUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 选项卡容器
 * @author : xujunjie (yinhunfeixue@163.com)
 * @date   : 2017-12-1 09:27:13
 */
var ViewStack = function (_SkinableComponent) {
	_inherits(ViewStack, _SkinableComponent);

	function ViewStack() {
		_classCallCheck(this, ViewStack);

		return _possibleConstructorReturn(this, (ViewStack.__proto__ || Object.getPrototypeOf(ViewStack)).apply(this, arguments));
	}

	_createClass(ViewStack, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(ViewStack.prototype.__proto__ || Object.getPrototypeOf(ViewStack.prototype), '_initProperty', this).call(this);
			this.ITEM_NAME = 'item';
			this.CONTAINER_NAME = 'container';
			this._children = [];
			this._lastIndex = -1;
			this._selectedIndex = -1;
		}
	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _ViewStackSkin2.default;
		}
	}, {
		key: 'initItems',
		value: function initItems() {
			this.clear();
			var children = this._children;
			if (children) {
				for (var i = 0; i < children.length; i++) {
					var item = children[i];
					var key = item.key;
					if (key) {
						this.addItem(key, item);
					} else {
						throw new RangeError('viewStack的第' + i + '项缺少key值');
					}
				}
			}
		}
	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(ViewStack.prototype.__proto__ || Object.getPrototypeOf(ViewStack.prototype), '_initSkin', this).call(this);
			this._adpteSelectedIndex(this._selectedIndex);
		}
	}, {
		key: 'addItem',
		value: function addItem(key, item) {
			this.addItemAt(key, item, this._listItems.length);
		}
	}, {
		key: 'addItemAt',
		value: function addItemAt(key, item, index) {
			index = _NumberUtil2.default.limit(index, 0, this._listItems.length);
			this._dicItems[key] = {};
			//先添加子元素，但是不创建容器，容器在第一次显示时再创建
			this._dicItems[key][this.ITEM_NAME] = item;
			this._listItems.splice(index, 0, item);
		}
	}, {
		key: 'removeItem',
		value: function removeItem(key) {
			var item = this._dicItems[key][this.ITEM_NAME];
			if (item) {
				var index = this._listItems.indexOf(item);
				this.removeItemAt(index);
			}
		}
	}, {
		key: 'removeItemAt',
		value: function removeItemAt(index) {
			if (index >= 0 && index < this._listItems.length) {
				var item = this._listItems[index];
				this._listItems.splice(index, 1);
				for (var key in this._dicItems) {
					if (this._dicItems[key] === item) {
						if (this.container) {
							this.container.removeChild(this._dicItems[key][this.CONTAINER_NAME]);
						}
						delete this._dicItems[key];
						break;
					}
				}
				this._adpteSelectedIndex(this._selectedIndex);
			}
		}
	}, {
		key: '_adpteSelectedIndex',
		value: function _adpteSelectedIndex(value) {
			//如果有子对象，必须选中一项
			var newIndex = value;
			if (this._listItems && this._listItems.length > 0) {
				newIndex = _NumberUtil2.default.limit(value, 0, this._listItems.length - 1);
			} else {
				newIndex = -1;
			}
			if (newIndex !== this._lastIndex) {
				this._selectedIndex = newIndex;
				if (this.container) {
					//隐藏上一次选中的项
					if (this._lastIndex >= 0) {
						var lastKey = this._getKey(this._listItems[this._lastIndex]);
						var lastContainer = this._dicItems[lastKey][this.CONTAINER_NAME];
						if (lastContainer) {
							lastContainer.style.display = 'none';
						}
					}
					if (this.selectedIndex >= 0) {
						//如果未初始化过，则进行初始化
						var key = this._getKey(this.selectedItem);
						if (!this._dicItems[key][this.CONTAINER_NAME]) {
							this._dicItems[key][this.CONTAINER_NAME] = document.createElement('div');
							_reactDom2.default.render(this.selectedItem, this._dicItems[key][this.CONTAINER_NAME]);
							this.container.appendChild(this._dicItems[key][this.CONTAINER_NAME]);
						}
						this._dicItems[key][this.CONTAINER_NAME].style.display = 'unset';
					}
				}
			}
		}
	}, {
		key: '_getKey',
		value: function _getKey(item) {
			for (var key in this._dicItems) {
				if (this._dicItems[key][this.ITEM_NAME] === item) {
					return key;
				}
			}
			return null;
		}
	}, {
		key: 'clear',
		value: function clear() {
			this._listItems = [];
			this._dicItems = {};
			if (this.container) {
				this.container.innerHTML = '';
			}
		}
	}, {
		key: 'children',
		get: function get() {
			return this._children;
		},
		set: function set(value) {
			if (!_ObjectUtil2.default.isEqual(this._children, value)) {
				this._children = value;
				this.initItems();
			}
		}
	}, {
		key: 'container',
		get: function get() {
			return this.findSkinPart('container');
		}
	}, {
		key: 'selectedItem',
		get: function get() {
			return this._listItems[this._selectedIndex];
		}
	}, {
		key: 'selectedIndex',
		get: function get() {
			return this._selectedIndex;
		},
		set: function set(value) {
			if (this._selectedIndex !== value) {
				this._lastIndex = this._selectedIndex;
				this._selectedIndex = value;
				this.forceUpdate();
			}
		}
	}]);

	return ViewStack;
}(_SkinableComponent3.default);

exports.default = ViewStack;
//# sourceMappingURL=ViewStack.js.map