'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('../SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _ButtonSkin = require('../../skins/ButtonSkin');

var _ButtonSkin2 = _interopRequireDefault(_ButtonSkin);

var _SystemUtil = require('../../utils/SystemUtil');

var _SystemUtil2 = _interopRequireDefault(_SystemUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 按钮基础类
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author : xujunjie 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @mail   : yinhunfeixue@163.com
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @date   : 2017/9/6 下午3:19:09
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * 按钮类，文字不可选中，具有长按功能
 * @extends SkinableComponent
 * @private
 */
var ButtonBase = function (_SkinableComponent) {
	_inherits(ButtonBase, _SkinableComponent);

	function ButtonBase() {
		_classCallCheck(this, ButtonBase);

		return _possibleConstructorReturn(this, (ButtonBase.__proto__ || Object.getPrototypeOf(ButtonBase)).apply(this, arguments));
	}

	_createClass(ButtonBase, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(ButtonBase.prototype.__proto__ || Object.getPrototypeOf(ButtonBase.prototype), '_initProperty', this).call(this);
			this._label = 'button';
			this._isMouseOver = false;
			this._isMouseDown = false;
			this._selectedAble = false;
		}

		/**
   * @inheritdoc
   * 
   */

	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _ButtonSkin2.default;
		}

		/**
   * @private
   */

	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			if (_get(ButtonBase.prototype.__proto__ || Object.getPrototypeOf(ButtonBase.prototype), 'componentDidMount', this)) {
				_get(ButtonBase.prototype.__proto__ || Object.getPrototypeOf(ButtonBase.prototype), 'componentDidMount', this).call(this);
			}
			var mouseEvents = ['mouseenter', 'mouseleave', 'mousedown', 'mouseup'];
			var touchEvents = ['touchstart', 'touchend'];

			var useEvents = _SystemUtil2.default.isMobile() ? touchEvents : mouseEvents;
			useEvents.forEach(function (value) {
				return _this2.rootComponent.addEventListener(value, _this2.mouseEventHandler.bind(_this2));
			}, this);
		}

		/**
  	 * @private
  	 */

	}, {
		key: 'mouseEventHandler',
		value: function mouseEventHandler(event) {
			switch (event.type) {
				case 'mouseenter':
					{
						this._isMouseOver = true;
						break;
					}
				case 'mouseleave':
				case 'touchend':
					{
						this._isMouseOver = false;
						this._isMouseDown = false;
						break;
					}
				case 'mousedown':
					{
						this._isMouseDown = true;
						break;
					}
				case 'touchstart':
					{
						this._isMouseOver = true;
						this._isMouseDown = true;
						break;
					}
				case 'mouseup':
					{
						this._isMouseDown = false;
						break;
					}
				default:
					{
						break;
					}
			}
			this._updateSkinStatus();
		}

		/**
   * 皮肤状态
   * 
   * @property unable 不可用的状态
   * @property down 鼠标/手指 按下的状态
   * @property over 鼠标移上但是未按下的状态（移动端无此状态）
   */

	}, {
		key: '_getCurrentSkinStatus',
		value: function _getCurrentSkinStatus() {
			if (!this.enable) {
				return 'unable';
			} else {
				if (this._isMouseDown) {
					return 'down';
				} else if (this._isMouseOver) {
					return 'over';
				} else {
					return '';
				}
			}
		}

		/**
   * 按钮文本
   * @type {string}
   * 
   * @default button
   */

	}, {
		key: 'label',
		get: function get() {
			return this._label;
		},
		set: function set(value) {
			this._label = value;
			this.forceUpdate();
		}
	}]);

	return ButtonBase;
}(_SkinableComponent3.default);

exports.default = ButtonBase;
//# sourceMappingURL=ButtonBase.js.map