'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('../SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _RemoteEvent = require('../../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * 数据源显示项
 * @author: xujunjie 
 * @Date: 2017-09-28 17:12:07 
 * @Last Modified time: 2017-10-09 09:22:31
 * @private
 */
var ItemRender = function (_SkinableComponent) {
	_inherits(ItemRender, _SkinableComponent);

	function ItemRender() {
		_classCallCheck(this, ItemRender);

		return _possibleConstructorReturn(this, (ItemRender.__proto__ || Object.getPrototypeOf(ItemRender)).apply(this, arguments));
	}

	_createClass(ItemRender, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(ItemRender.prototype.__proto__ || Object.getPrototypeOf(ItemRender.prototype), '_initProperty', this).call(this);
			this._data = null;
			this._labelFunction = null;
			this._changeHandler = null;
			this._selected = false;
		}

		/**
   * 用于显示文本标签的函数,格式为fun(data)，返回值类型string
   * 
   * @type {function}
   * 
   * @memberof ItemRender
   */

	}, {
		key: '_getCurrentSkinStatus',


		/**
   * 皮肤状态
   * @property {string} unable 禁用
   * @property {string} selected 选中
   * @property {string} unable-selected 选中且禁用
   */
		value: function _getCurrentSkinStatus() {
			var superStatus = _get(ItemRender.prototype.__proto__ || Object.getPrototypeOf(ItemRender.prototype), '_getCurrentSkinStatus', this).call(this);
			var result = [];
			if (superStatus) {
				result.push(superStatus);
			}

			if (this.selected) {
				result.push('selected');
			}
			return result.join('-');
		}

		/**
   * 表示是否选中
   */

	}, {
		key: 'labelFunction',
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this.forceUpdate();
			}
		}
	}, {
		key: 'selected',
		get: function get() {
			return this._selected;
		},
		set: function set(value) {
			if (this._selected !== value) {
				this._selected = value;
				this._updateSkinStatus();
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
			}
		}

		/**
   * 选中后的处理函数，参数为RemoteEvent#Change
   * 
   */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_RemoteEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}

		/**
   * 默认显示的文本标签
   * 1、如果labelFunction有值，则使用labelFunction计算
   * 2、否则，如果data有值，则使用data.toString()
   * 3、如果data也无值，则返回''
   * @readonly
   * @memberof ItemRender
   */

	}, {
		key: 'label',
		get: function get() {
			if (this.data) {
				if (this._labelFunction) {
					return this._labelFunction(this.data);
				} else {
					return this.data.toString();
				}
			}
			return '';
		}

		/**
   * 携带的数据
   * @type {any}
   * @default null
   */

	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			if (this._data !== value) {
				this._data = value;
				this.forceUpdate();
			}
		}
	}]);

	return ItemRender;
}(_SkinableComponent3.default);

exports.default = ItemRender;
//# sourceMappingURL=ItemRender.js.map