'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _RemoteEvent = require('../../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

var _SkinableComponent2 = require('../SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 拥有一组子项，其中只能有一个子项被选中
 * 
 * @date   : 2017-9-19 13:48:51
 * 
 * @extends SkinableComponent
 */
var ListBase = function (_SkinableComponent) {
	_inherits(ListBase, _SkinableComponent);

	function ListBase(props) {
		_classCallCheck(this, ListBase);

		//优先使用selectedIndex做为选中项
		var _this = _possibleConstructorReturn(this, (ListBase.__proto__ || Object.getPrototypeOf(ListBase)).call(this, props));

		if (_this.props.selectedIndex !== undefined) {
			_this.selectedIndex = _this.props.selectedIndex;
		} else if (_this.props.selectedValue) {
			_this.selectedValue = _this.props.selectedValue;
		}
		return _this;
	}

	/**
 * 子项类型
 * @type {function}
 * @default {@link ListItemRender}
 */


	_createClass(ListBase, [{
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(ListBase.prototype.__proto__ || Object.getPrototypeOf(ListBase.prototype), '_initProperty', this).call(this);
			this._labelFunction = null;
			this._itemClassType = null;
			this._selectedIndex = -1;
			this._changeHandler = null;
			this._children = [];
		}

		/**
   * 根据data生成显示文字的方法。
   * 此方法格式为func(item, index)， item是数据，index是数据所在的位置
   * 生成显示文字有三种方法，优先级为：显式设置label属性 > labelFunction(data) > data.toString()
   * 
   * @type {function}
   */

	}, {
		key: '_translateData',


		/**
   * 把外部数据源转换成指定格式的数据源
   * @param {*} data 携带的数据
   * 
   * @private
   */
		value: function _translateData(data) {
			if (data) {
				var result = [];
				for (var i = 0; i < data.length; i++) {
					result.push({ value: data[i] });
				}
				return result;
			}
			return [];
		}

		/**
   * 根据数据项，创建对应的显示文本
   * @param {object} itemData 数据，value值
   * @param {number} index 数据在集合中的位置
   * 
   * @private
   */

	}, {
		key: '_createLabel',
		value: function _createLabel(itemData, index) {
			//优先使用labelFunction,最后使用toString()
			if (itemData) {
				if (this._labelFunction) {
					return this._labelFunction(itemData, index);
				} else if (itemData.toString) {
					return itemData.toString();
				}
			}
			return '';
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(ListBase.prototype.__proto__ || Object.getPrototypeOf(ListBase.prototype), '_initSkin', this).call(this);
			this._renderItems();
		}

		/**
   * 皮肤部件，表示子项的容器
   */

	}, {
		key: '_createItemProps',


		/**
   * 创建一项的props
   * @protected
   * @param {*} data 
   * @param {*} index 
   */
		value: function _createItemProps(data, index) {
			return {
				key: index,
				data: data,
				index: index,
				label: this._createLabel(data, index),
				enable: this.enable
			};
		}
		/**
   * @private
   */

	}, {
		key: '_renderItems',
		value: function _renderItems() {
			var _this2 = this;

			if (this.container && this._children) {
				var elements = this._children.map(function (item, index, array) {
					return _react2.default.createElement(_this2.itemClassType, _this2._createItemProps(item.value, index));
				});
				_reactDom2.default.render(elements, this.container);
			}
		}
	}, {
		key: 'itemClassType',
		get: function get() {
			return this._itemClassType;
		},
		set: function set(value) {
			if (this._itemClassType !== value) {
				this._itemClassType = value;
			}
		}
	}, {
		key: 'labelFunction',
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 设置数据源。
   * @type {Array}
   */

	}, {
		key: 'data',
		get: function get() {
			var result = [];
			if (this._children) {
				for (var i = 0; i < this._children.length; i++) {
					result.push(this._children[i].value);
				}
			}
			return result;
		},
		set: function set(value) {
			this._children = this._translateData(value);
			this.forceUpdate();
		}

		/**
   * 选中项变化后执行的函数，事件类型{@link RemoteEvent#CHANGE}
   * @type {function}
   */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_RemoteEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}

		/**
   * 表示当前选中项的位置
   * 初始化时优先级问题，请参考{@link RadioButtonGroup#selectedValue selectedValue}
   * 
   * @type {number}
   */

	}, {
		key: 'selectedIndex',
		get: function get() {
			return this._selectedIndex;
		},
		set: function set(value) {
			if (this._selectedIndex !== value) {
				this._selectedIndex = value;
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
				this.forceUpdate();
			}
		}

		/**
   * 组中所选 RadioButton 组件的 Value 属性。
   * 设置选中项，有两种设置办法：selectedValue，selectedIndex。
   * 在初始化时，优先级为：selectedIndex > selectedValue。
   * <font color='red'>通过此方法设置选中项，如果有重复值，会选中重复值的第一项。</font>
   * @type {*}
   */

	}, {
		key: 'selectedValue',
		get: function get() {
			return this.data[this.selectedIndex];
		},
		set: function set(value) {
			if (!this._children) {
				return;
			}

			var newIndex = -1;
			for (var i = 0; i < this._children.length; i++) {
				if (this._children[i].value === value) {
					newIndex = i;
					break;
				}
			}
			this.selectedIndex = newIndex;
		}
	}, {
		key: 'container',
		get: function get() {
			return this.findSkinPart('container');
		}
	}]);

	return ListBase;
}(_SkinableComponent3.default);

exports.default = ListBase;
//# sourceMappingURL=ListBase.js.map