'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('../SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _Point = require('../../core/Point');

var _Point2 = _interopRequireDefault(_Point);

var _HtmlUtil = require('../../utils/HtmlUtil');

var _HtmlUtil2 = _interopRequireDefault(_HtmlUtil);

var _NumberUtil = require('../../utils/NumberUtil');

var _NumberUtil2 = _interopRequireDefault(_NumberUtil);

var _RemoteEvent = require('../../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 滑块基类
 * 
 * <h3>皮肤部件</h3>
 * <ol>
 * 	<li>track 轨道</li>
 * 	<li>thumb 滑块</li>
 * </ol>
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/9 下午2:44:08
 * 
 * @extends SkinableComponent
 */
var SliderBase = function (_SkinableComponent) {
	_inherits(SliderBase, _SkinableComponent);

	function SliderBase() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, SliderBase);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SliderBase.__proto__ || Object.getPrototypeOf(SliderBase)).call.apply(_ref, [this].concat(args))), _this), _this._thumbMouseDownHandler = function (event) {
			if (_this.enable) {
				_this._moving = true;
				_this._updateSkinStatus();
				_this._mouseDownPoint = new _Point2.default(event.pageX, event.pageX);
				document.addEventListener('mousemove', _this._thumbMouseMoveHandler);
				document.addEventListener('mouseup', _this._thumbMouseUpHandler);
			}
		}, _this._thumbMouseMoveHandler = function (event) {
			if (_this.enable) {
				var point = _HtmlUtil2.default.globalToLocal(new _Point2.default(event.pageX, event.pageY), _this.track);
				_this.value = _this._pointToValue(point);
			}
		}, _this._thumbMouseUpHandler = function (event) {
			_this._moving = false;
			_this._updateSkinStatus();
			document.removeEventListener('mousemove', _this._thumbMouseMoveHandler);
			document.removeEventListener('mouseup', _this._thumbMouseUpHandler);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(SliderBase, [{
		key: '_pointToValue',


		/**
   * 相对于轨道的显示坐标点转换为滑块值
   * @param {Point} point 相对轨道的坐标点
   * 
   * @return {Number} 对应的滑块值
   * 
   * @protected
   */
		value: function _pointToValue(point) {}

		/**
   * 滑块值转换为相对于轨道的坐标点
   * 
   * @return {Point} 相对轨道的坐标点
   * 
   * @protected
   */

	}, {
		key: '_valueToPoint',
		value: function _valueToPoint() {}

		/**
   * 滑块最大值
   * 
   * @type {number}
   * @default 100
   * @memberof SliderBase
   */

	}, {
		key: '_initProperty',


		/**
   * @inheritdoc
   */
		value: function _initProperty() {
			_get(SliderBase.prototype.__proto__ || Object.getPrototypeOf(SliderBase.prototype), '_initProperty', this).call(this);
			this._minValue = 0;
			this._maxValue = 100;
			this._value = 0;
			this._stepSize = 1;
			this._mouseDownPoint = null;
			this._changeHandler = null;
			this._moving = false;
		}

		/**
   * 步进值，滑块值最小变化单位
   * 
   * @type {number}
   * @default 1
   * @memberof SliderBase
   */

	}, {
		key: '_updateThumbPosition',


		/**
   * 更新滑块位置
   * @private
   */
		value: function _updateThumbPosition() {
			if (this.inited && this.thumb) {
				var positon = this._valueToPoint();
				this.thumb.style.left = positon.x + 'px';
				this.thumb.style.top = positon.y + 'px';
			}
		}

		/**
   * @private
   */


		/**
   * @private
   */


		/**
   * @private
   */

	}, {
		key: '_initSkin',


		/**
   * @inheritdoc
   */
		value: function _initSkin() {
			_get(SliderBase.prototype.__proto__ || Object.getPrototypeOf(SliderBase.prototype), '_initSkin', this).call(this);
			if (this.thumb != null) {
				this.thumb.style.position = 'absolute';
				this.thumb.addEventListener('mousedown', this._thumbMouseDownHandler);
			}
			if (this.track) {
				this.track.style.position = 'relative';
			}
			this._updateThumbPosition();
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_unstallSkin',
		value: function _unstallSkin() {
			if (this.thumb != null) {
				this.thumb.removeEventListener('mousedown', this._thumbMouseDownHandler);
			}
			document.removeEventListener('mousemove', this._thumbMouseMoveHandler);
			document.removeEventListener('mouseup', this._thumbMouseUpHandler);
			_get(SliderBase.prototype.__proto__ || Object.getPrototypeOf(SliderBase.prototype), '_installSkin', this).call(this);
		}

		/**
   * 当前皮肤状态
   * 
   * @property {string} unable 组件不可用状态
   * @property {string} moving 移动状态
   */

	}, {
		key: '_getCurrentSkinStatus',
		value: function _getCurrentSkinStatus() {
			var result = [];
			var superStatus = _get(SliderBase.prototype.__proto__ || Object.getPrototypeOf(SliderBase.prototype), '_getCurrentSkinStatus', this).call(this);
			if (superStatus) result.push(superStatus);

			if (this._moving) {
				result.push('moving');
			}
			return result.join('-');
		}
	}, {
		key: 'maxValue',
		get: function get() {
			return this._maxValue;
		},
		set: function set(v) {
			if (this._maxValue !== v) {
				this._maxValue = v;
				this.value = _NumberUtil2.default.limit(this.value, this._minValue, this._maxValue);
			}
		}

		/**
   * 滑块最小值
   * 
   * @type {number}
   * @default 0
   * @memberof SliderBase
   */

	}, {
		key: 'minValue',
		get: function get() {
			return this._minValue;
		},
		set: function set(v) {
			if (this._minValue !== v) {
				this._minValue = v;
				this.value = _NumberUtil2.default.limit(this.value, this._minValue, this._maxValue);
			}
		}

		/**
   * 滑块当前值
   * 
   * @type {number}
   * @default 0
   * @memberof SliderBase
   */

	}, {
		key: 'value',
		get: function get() {
			return this._value;
		},
		set: function set(v) {
			v = _NumberUtil2.default.limit(v, this._minValue, this._maxValue);
			if (this._value !== v) {
				this._value = v;
				this._updateThumbPosition();
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
				this.forceUpdate();
			}
		}

		/**
   * 皮肤部件：滑块
   * 
   * @readonly
   * @memberof SliderBase
   */

	}, {
		key: 'thumb',
		get: function get() {
			return this.findSkinPart('thumb');
		}

		/**
   * 皮肤部件：滑轨
   */

	}, {
		key: 'track',
		get: function get() {
			return this.findSkinPart('track');
		}
	}, {
		key: 'stepSize',
		get: function get() {
			return this._stepSize;
		},
		set: function set(value) {
			if (value !== this._stepSize) {
				this._stepSize = value;
				this._updateThumbPosition();
			}
		}

		/**
   * value发生变化时触发的函数，事件类型 {@link RemoteEvent#CHANGE}
   * 
   * @type {function}
   */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_RemoteEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}
	}]);

	return SliderBase;
}(_SkinableComponent3.default);

exports.default = SliderBase;
//# sourceMappingURL=SliderBase.js.map