'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _NumberUtil = require('../../utils/NumberUtil');

var _NumberUtil2 = _interopRequireDefault(_NumberUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-11 10:35:17
 */

var SliderUtil = function () {
	function SliderUtil() {
		_classCallCheck(this, SliderUtil);
	}

	_createClass(SliderUtil, null, [{
		key: 'pointToValue',


		/**
   * 显示位置转换为轨道值
   * @param {Number} position 相对轨道的显示位置，如果是水平坐标则取x，如果是竖直坐标，则取y
   * @param {Number} minValue 最小值
   * @param {Number} maxValue 最大值
   * @param {Number} stepSize 步进值
   * @param {Number} traceLength 轨道有效可见长度
   * @param {Number} thumbLength 滑块有效可见长度
   * 
   * @return {Number} 对应的轨道值
   */
		value: function pointToValue(position, minValue, maxValue, stepSize, traceLength, thumbLength) {
			var value = 0;
			var effectLength = traceLength; //轨道有效长度
			if (effectLength <= 0) {
				value = 0;
			}

			if (position < 0) {
				value = minValue;
			} else if (position >= effectLength) {
				value = maxValue;
			} else {
				value = minValue + (maxValue - minValue) * position / effectLength;
				if (stepSize > 0) {
					value = Math.round(value / stepSize) * stepSize;
				}
			}
			return value;
		}

		/**
   * 轨道值转换为显示位置
   * @param {Number} value 值
   * @param {Number} minValue 最小值
   * @param {Number} maxValue 最大值
   * @param {Number} trackLength 轨道长度
   * @param {Number} thumbLength 滑块长度
   */

	}, {
		key: 'valueToPosition',
		value: function valueToPosition(value, minValue, maxValue, trackLength, thumbLength) {
			var result = 0;
			var effectLength = trackLength;

			result = (value - minValue) / (maxValue - minValue) * effectLength;
			return _NumberUtil2.default.limit(result, 0, effectLength);
		}
	}]);

	return SliderUtil;
}();

exports.default = SliderUtil;
//# sourceMappingURL=SliderUtil.js.map