'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _ButtonBase2 = require('./ButtonBase');

var _ButtonBase3 = _interopRequireDefault(_ButtonBase2);

var _ToggleButtonSkin = require('../../skins/ToggleButtonSkin');

var _ToggleButtonSkin2 = _interopRequireDefault(_ToggleButtonSkin);

var _RemoteEvent = require('../../events/RemoteEvent');

var _RemoteEvent2 = _interopRequireDefault(_RemoteEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 选中状态可切换的按钮基类
 * 
 * @extends ButtonBase
 * @date    2017-09-06 15:38:02
 */
var ToggleButtonBase = function (_ButtonBase) {
	_inherits(ToggleButtonBase, _ButtonBase);

	function ToggleButtonBase() {
		_classCallCheck(this, ToggleButtonBase);

		return _possibleConstructorReturn(this, (ToggleButtonBase.__proto__ || Object.getPrototypeOf(ToggleButtonBase)).apply(this, arguments));
	}

	_createClass(ToggleButtonBase, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(ToggleButtonBase.prototype.__proto__ || Object.getPrototypeOf(ToggleButtonBase.prototype), '_initProperty', this).call(this);
			this._selected = false;
			this._changeHandler = null;
		}

		/**
   * @inheritdoc
   */

	}, {
		key: '_getDefaultSKinClass',
		value: function _getDefaultSKinClass() {
			return _ToggleButtonSkin2.default;
		}

		/**
   * 获取皮肤状态
   * @property '' 普通状态
   * @property unable 不可用的状态
   * @property down 鼠标/手指 按下的状态
   * @property over 鼠标移上但是未按下的状态（移动端无此状态）
   * @property selected 选中状态
   * @property down-selected 选中后，鼠标/手指 按下的状态
   * @property over-selected 选中后，鼠标移上但是未按下的状态（移动端无此状态）
   * @property unable-selected 选中且不可用状态
   */

	}, {
		key: '_getCurrentSkinStatus',
		value: function _getCurrentSkinStatus() {
			var result = [];
			var superStatus = _get(ToggleButtonBase.prototype.__proto__ || Object.getPrototypeOf(ToggleButtonBase.prototype), '_getCurrentSkinStatus', this).call(this);
			if (superStatus) result.push(superStatus);

			if (this.selected) {
				result.push('selected');
			}
			return result.join('-');
		}

		/**
   * 是否选中
   * @type {boolean}
   * 
   * @default false
   */

	}, {
		key: 'selected',
		get: function get() {
			return this._selected;
		},
		set: function set(value) {
			if (value !== this._selected) {
				this._selected = value;
				this._updateSkinStatus();
				this.dispatchEvent(new _RemoteEvent2.default(_RemoteEvent2.default.CHANGE));
			}
		}

		/**
   * 选中状态发生变化时触发的事件函数，事件类型{@link Event#CHANGE}
   *
   * @default null
   */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_RemoteEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}
	}]);

	return ToggleButtonBase;
}(_ButtonBase3.default);

exports.default = ToggleButtonBase;
//# sourceMappingURL=ToggleButtonBase.js.map