'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _SkinableComponent2 = require('../SkinableComponent');

var _SkinableComponent3 = _interopRequireDefault(_SkinableComponent2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DataEvent = require('../../events/DataEvent');

var _DataEvent2 = _interopRequireDefault(_DataEvent);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 所有树结构控件的基类
 * @author: xujunjie 
 * @Date: 2017-09-28 18:39:15 
 * @Last Modified time: 2017-10-09 09:23:04
 * 
 * @extends SkinableComponent
 * @private
 */
var TreeBase = function (_SkinableComponent) {
	_inherits(TreeBase, _SkinableComponent);

	function TreeBase() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TreeBase);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TreeBase.__proto__ || Object.getPrototypeOf(TreeBase)).call.apply(_ref, [this].concat(args))), _this), _this._createItemRender = function (itemValue, index) {
			var props = {
				key: index, data: itemValue,
				selected: itemValue === _this.selectedValue,
				changeHandler: _this._itemSelectedHandler.bind(_this),
				createItemRender: _this._createItemRender.bind(_this),
				selectedValue: _this.selectedValue
			};
			if (_this._itemSkinClass) {
				props.skinClass = _this._itemSkinClass;
			}
			if (_this.labelFunction) {
				props.labelFunction = _this.labelFunction;
			}
			return _react2.default.createElement(_this._itemClassType, props);
		}, _this._itemSelectedHandler = function (event) {
			var target = event.target;
			if (target.selected && _this._selectedValue !== target.data) {
				_this.selectedValue = target.data;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TreeBase, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(TreeBase.prototype.__proto__ || Object.getPrototypeOf(TreeBase.prototype), '_initProperty', this).call(this);
			this._data = null;
			this._selectedValue = null;
			this._changeHandler = null;
			this._itemSkinClass = null;
			this._labelFunction = null;
			this._selectedItem = null;
		}

		/**
   * 用于显示文本标签的函数,格式为fun(data)，返回值类型string
   */

	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(TreeBase.prototype.__proto__ || Object.getPrototypeOf(TreeBase.prototype), '_initSkin', this).call(this);
			this._renderItems();
		}
	}, {
		key: '_renderItems',
		value: function _renderItems() {
			if (this.container && this._data !== null && this._data.length > 0) {
				var elements = [];
				for (var i = 0; i < this._data.length; i++) {
					var itemData = this._data[i];
					elements.push(this._createItemRender(itemData, i));
				}
				_reactDom2.default.render(elements, this.container);
			}
		}
	}, {
		key: 'container',
		get: function get() {
			return this.findSkinPart('container');
		}
	}, {
		key: 'labelFunction',
		get: function get() {
			return this._labelFunction;
		},
		set: function set(value) {
			if (this._labelFunction !== value) {
				this._labelFunction = value;
				this.forceUpdate();
			}
		}

		/**
   * 子项的皮肤类型
   */

	}, {
		key: 'itemSkinClass',
		get: function get() {
			return this._itemClassType;
		},
		set: function set(value) {
			if (this._itemSkinClass !== value) {
				this._itemSkinClass = value;
				this.forceUpdate();
			}
		}

		/**
   * 选中项变化时响应函数,参数为DataEvent对象
   * @type {function}
   * @default null
   */

	}, {
		key: 'changeHandler',
		get: function get() {
			return this._changeHandler;
		},
		set: function set(value) {
			if (this._changeHandler !== value) {
				this._changeEventListener(_DataEvent2.default.CHANGE, value, this._changeHandler);
				this._changeHandler = value;
			}
		}

		/**
   * 当前选中的数据
   * @type {TreeNodeData}
   */

	}, {
		key: 'selectedValue',
		get: function get() {
			return this._selectedValue;
		},
		set: function set(value) {
			if (this._selectedValue !== value) {
				this._selectedValue = value;
				this.forceUpdate();
				this.dispatchEvent(new _DataEvent2.default(_DataEvent2.default.CHANGE, value));
			}
		}

		/**
   * 数据，子项是TreeNodeData类型的数据
   * data属性和labelFunction决定了label属性
   * @type {array}
   */

	}, {
		key: 'data',
		get: function get() {
			return this._data;
		},
		set: function set(value) {
			this._data = value;
			this.forceUpdate();
		}

		/**
   * 默认获取结点的类的函数
   * @param {TreeNodeData} itemValue 结点的数据
   * 
   * @protected
   */

	}, {
		key: '_itemClassType',


		/**
   * @protected
   */
		get: function get() {
			return null;
		}

		/**
   * 当前选中的子项实例
   */

	}, {
		key: 'selectedItem',
		get: function get() {
			return this._selectedItem;
		}

		/**
   * @protected
   */

	}]);

	return TreeBase;
}(_SkinableComponent3.default);

exports.default = TreeBase;
//# sourceMappingURL=TreeBase.js.map