'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _set = function set(object, property, value, receiver) { var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent !== null) { set(parent, property, value, receiver); } } else if ("value" in desc && desc.writable) { desc.value = value; } else { var setter = desc.set; if (setter !== undefined) { setter.call(receiver, value); } } return value; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _ItemRender2 = require('./ItemRender');

var _ItemRender3 = _interopRequireDefault(_ItemRender2);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _ArrayUtil = require('../../utils/ArrayUtil');

var _ArrayUtil2 = _interopRequireDefault(_ArrayUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-30 09:54:15
 */
var TreeItemRenderBase = function (_ItemRender) {
	_inherits(TreeItemRenderBase, _ItemRender);

	function TreeItemRenderBase() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TreeItemRenderBase);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TreeItemRenderBase.__proto__ || Object.getPrototypeOf(TreeItemRenderBase)).call.apply(_ref, [this].concat(args))), _this), _this._createChildrenItem = function () {
			var result = null;
			if (_this.data && !_ArrayUtil2.default.isEmpty(_this.data.children)) {
				result = _this.data.children.map(function (value, index, array) {
					return _this.props.createItemRender(value, index);
				});
			}
			return result;
		}, _this._nodeContainerClickHandler = function (event) {
			_this.selected = true;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TreeItemRenderBase, [{
		key: '_initProperty',
		value: function _initProperty() {
			_get(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), '_initProperty', this).call(this);
			this._isOpen = false;
			this._children = null;
		}
	}, {
		key: '_getCurrentSkinStatus',


		/**
   * 当前皮肤状态
   * normal--普通状态
   * open--打开状态
   * selected——选中状态
   * open-selected——打开且选中
   */
		value: function _getCurrentSkinStatus() {
			var result = [];
			if (this._isOpen) result.push('open');
			if (this._selected) result.push('selected');
			if (result.length === 0) result.push('normal');
			return result.join('-');
		}

		/**
  * 
  * @type {}
  * @default 
  */

	}, {
		key: '_initSkin',
		value: function _initSkin() {
			_get(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), '_initSkin', this).call(this);

			this._renderChildren();
			if (this.nodeContainer) {
				this.nodeContainer.onclick = this._nodeContainerClickHandler;
			}
		}

		/**
   * 
   * @private
   */

	}, {
		key: '_renderChildren',
		value: function _renderChildren() {
			if (this.isOpen) {
				if (this._isOpen) {
					this._children = this._createChildrenItem();
				}
				if (this.childrenContainer && this._children !== null) {
					_reactDom2.default.render(this._children, this.childrenContainer);
				}
			}
		}
	}, {
		key: 'label',

		/**
   * 默认显示的文本标签
   * 1、如果labelFunction有值，则使用labelFunction计算
   * 2、否则，如果data:TreeNodeData有值，则使用data.data.toString()
   * 3、如果data也无值，则返回''
   * @readonly
   * @memberof ItemRender
   */
		get: function get() {
			if (this.data) {
				if (this._labelFunction) {
					return this._labelFunction(this.data);
				} else if (this.data.value) {
					return this.data.value.toString();
				}
			}
			return '';
		}
	}, {
		key: 'levelIndex',
		get: function get() {
			if (this.data) {
				return this.data.levelIndex;
			}
			return 0;
		}
	}, {
		key: 'childrenCount',
		get: function get() {
			if (!this.data || !this.data.children) {
				return 0;
			}
			return this.data.children.length;
		}
	}, {
		key: 'isOpen',
		get: function get() {
			return this._isOpen;
		},
		set: function set(value) {
			if (this._isOpen !== value) {
				this._isOpen = value;
				this._updateSkinStatus();
				this._renderChildren();
			}
		}
	}, {
		key: 'skinClass',
		get: function get() {
			return _get(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), 'skinClass', this);
		},
		set: function set(value) {
			_set(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), 'skinClass', value, this);

			//皮肤类变化，重建子项
			this._children = null;
			this._renderChildren();
		}
	}, {
		key: 'selectedValue',
		get: function get() {
			return this._selectedValue;
		},
		set: function set(value) {
			if (this._selectedValue !== value) {
				this._selectedValue = value;
				this.forceUpdate();
			}
		}

		/**
   * 子结点的容器
   */

	}, {
		key: 'childrenContainer',
		get: function get() {
			return this.findSkinPart('childrenContainer');
		}

		/**
   * 当前结点内容的显示容器
   */

	}, {
		key: 'nodeContainer',
		get: function get() {
			return this.findSkinPart('nodeContainer');
		}
	}, {
		key: 'data',
		get: function get() {
			return _get(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), 'data', this);
		},
		set: function set(value) {
			var oldSelected = this.selected;
			_set(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), 'data', value, this);
			if (oldSelected !== this.data.selected) {
				this.selected = this.data.selected;
			}

			//数据变化，重建子项
			this._children = null;
			this._renderChildren();
		}
	}, {
		key: 'selected',
		get: function get() {
			if (this.data) {
				return this.data.selected;
			}
			return this._selected;
		},
		set: function set(value) {
			if (this._selected !== value) {
				if (this.data) {
					this.data.selected = value;
				}
				_set(TreeItemRenderBase.prototype.__proto__ || Object.getPrototypeOf(TreeItemRenderBase.prototype), 'selected', value, this);
			}
		}
	}]);

	return TreeItemRenderBase;
}(_ItemRender3.default);

exports.default = TreeItemRenderBase;
//# sourceMappingURL=TreeItemRenderBase.js.map