"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 
 * 表示一个二维坐标的点,也可以表示一个向量
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/9 下午4:48:20
 */
var Point = function () {

	/**
  * 实例化二维坐标点
  * @param {number} x x坐标
  * @param {number} y y坐标
  */
	function Point() {
		var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
		var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

		_classCallCheck(this, Point);

		this.x = x;
		this.y = y;
	}

	/**
  * 将另一个点的坐标添加到此点的坐标，此方法会修改当前point实例
  * @param {number} x 要增加的x坐标
  * @param {number} y 要增加的y坐标
  * @return 当前Point实例
  */


	_createClass(Point, [{
		key: "add",
		value: function add(x, y) {
			this.x += x;
			this.y += y;
			return this;
		}

		/**
   * 将另一个点的坐标添加到此点的坐标
   * @param {Point} point 要添加的点
   * @return 当前Point实例
   */

	}, {
		key: "addPoint",
		value: function addPoint(point) {
			this.x += point.x;
			this.y += point.y;
			return this;
		}

		/**
   * 从此点的坐标中减去另一个点的坐标
   * @param {number} x 要减去的x坐标
   * @param {number} y 要减去的y坐标
   * @return 当前Point实例
   */

	}, {
		key: "sub",
		value: function sub(x, y) {
			this.x -= x;
			this.y -= y;
			return this;
		}

		/**
   * 从此点的坐标中减去另一个点的坐标
   * @param {Point} point 要减去的点
   * @return 当前Point实例
   */

	}, {
		key: "subPoint",
		value: function subPoint(point) {
			this.x -= point.x;
			this.y -= point.y;
			return this;
		}

		/**
   * 复制一个新的Point实例
   */

	}, {
		key: "clone",
		value: function clone() {
			return new Point(this.x, this.y);
		}
	}]);

	return Point;
}();

exports.default = Point;
//# sourceMappingURL=Point.js.map