'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Mask = require('../components/Mask');

var _Mask2 = _interopRequireDefault(_Mask);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _ObjectUtil = require('../utils/ObjectUtil');

var _ObjectUtil2 = _interopRequireDefault(_ObjectUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 弹出层管理器
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017-9-21 14:53:54
 */

var PopupManager = function () {
	function PopupManager() {
		_classCallCheck(this, PopupManager);
	}

	_createClass(PopupManager, null, [{
		key: 'addPopUp',


		/**
   * 弹出指定对象
   * @param {Object} target 要弹出的对象
   * @param {boolean} isCenter 是否居中显示弹出对象，如果不居中，需要自行设置位置
   * @param {boolean} isModal 是否用模态弹出，模态弹出会在弹出对象下方添加一个遮挡层
  * @param {string} key 弹出对象的标识，如果不设置，则等于target。此参数不可重复，如果重复，无法弹出
   */
		value: function addPopUp(target) {
			var isCenter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
			var isModal = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
			var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

			if (key === null) key = target;

			if (PopupManager._containerDic.has(key)) {
				throw new Error(key + '弹出对象已存在');
			}

			//创建不可见的容器
			var container = document.createElement('div');
			document.body.appendChild(container);

			PopupManager._containerDic.set(key, container);

			var children = target;

			//如果是模态窗口，创建模态层
			if (isModal) {
				children = _react2.default.createElement(
					'div',
					{ style: PopupManager._css },
					_react2.default.createElement(_Mask2.default, null),
					_react2.default.createElement(
						'div',
						{ style: isCenter ? _ObjectUtil2.default.Merge(PopupManager._css, PopupManager._centerCss) : PopupManager._css },
						target
					)
				);
			}
			_reactDom2.default.render(children, container);
		}

		/**
   * 移除弹出对象
   * @param {*} key 弹出对象标识
   */

	}, {
		key: 'removePopUp',
		value: function removePopUp(key) {
			if (PopupManager._containerDic.has(key)) {
				var container = PopupManager._containerDic.get(key);
				document.body.removeChild(container);
				_reactDom2.default.unmountComponentAtNode(container);
				PopupManager._containerDic.delete(key);
			}
		}
	}]);

	return PopupManager;
}();

PopupManager._containerDic = new Map();
PopupManager._css = {
	top: 0,
	left: 0,
	bottom: 0,
	right: 0,
	zIndex: 1000,
	position: 'fixed'
};
PopupManager._centerCss = {
	display: 'flex',
	justifyContent: 'center',
	alignItems: 'center'
};
exports.default = PopupManager;
//# sourceMappingURL=PopupManager.js.map