'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EventDispatcher2 = require('../core/EventDispatcher.js');

var _EventDispatcher3 = _interopRequireDefault(_EventDispatcher2);

var _ProgressEvent = require('../events/ProgressEvent');

var _ProgressEvent2 = _interopRequireDefault(_ProgressEvent);

var _DataEvent = require('../events/DataEvent');

var _DataEvent2 = _interopRequireDefault(_DataEvent);

var _ErrorEvent = require('../events/ErrorEvent');

var _ErrorEvent2 = _interopRequireDefault(_ErrorEvent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * 
 * @author : xujunjie (yinhunfeixue@163.com)
 * @date   : 2017-12-26 09:19:24
 */
var Loader = function (_EventDispatcher) {
	_inherits(Loader, _EventDispatcher);

	function Loader() {
		_classCallCheck(this, Loader);

		var _this = _possibleConstructorReturn(this, (Loader.__proto__ || Object.getPrototypeOf(Loader)).call(this));

		_this.readystatechangeHandler = function (event) {
			if (_this._xhr.readyState === 4) {
				if (_this._xhr.status === 200) {
					_this._data = _this._xhr.response;
					_this._status = Loader.COMPLETE;
					_this.dispatchEvent(new _DataEvent2.default(_DataEvent2.default.COMPLETE, _this._data));
				} else {
					_this.reset();
					_this._status = Loader.ERROR;
					_this.dispatchEvent(new _ErrorEvent2.default(_ErrorEvent2.default.ERROR));
				}
			}
		};

		_this.progressHandler = function (event) {
			_this._byteLoaded = event.loaded;
			_this._byteTotal = event.total;
			if (_this.hasEventListener(_ProgressEvent2.default.PROGRESS)) {
				_this.dispatchEvent(new _ProgressEvent2.default(_ProgressEvent2.default.PROGRESS, event.loaded, event.total));
			}
		};

		_this._loading = false;
		_this._data = null;
		_this._byteLoaded = 0;
		_this._byteTotal = 0;
		_this._status = Loader.UNSTART;
		_this._xhr = new XMLHttpRequest();
		_this._urlRequest = null;
		return _this;
	}

	_createClass(Loader, [{
		key: 'load',


		/**
   * 发起请求，如果正在进行请求，此方法将强制中止当前请求
   * 如果不希望意外中止正在进行请求，建议创建新的Loader，或者先判断loadin为false时，再使用此方法
   * @param {UrlRequest} request 请求参数
   */
		value: function load(urlRequest) {
			this._urlRequest = urlRequest;
			if (urlRequest && urlRequest.url) {
				this.reset();
				var xhr = this._xhr;
				if (this._loading) {
					this.close();
				}
				xhr.onreadystatechange = this.readystatechangeHandler;
				xhr.onprogress = this.progressHandler;
				xhr.open(urlRequest.method, urlRequest.url);
				if (urlRequest.contentType) {
					xhr.responseType = urlRequest.contentType;
				}
				if (urlRequest.headers) {
					for (var key in urlRequest.headers) {
						xhr.setRequestHeader(key, urlRequest.headers[key]);
					}
				}
				xhr.send(urlRequest.data);
				this._status = Loader.LOADING;
			} else {
				throw new Error('urlRequest为null，或者url为null');
			}
		}
	}, {
		key: 'close',
		value: function close() {
			this._xhr.onreadystatechange = null;
			this._xhr.onprogress = null;
			this._xhr.abort();
		}
	}, {
		key: 'reset',
		value: function reset() {
			this.close();
			this._status = Loader.UNSTART;
			this._byteLoaded = 0;
			this._byteTotal = 0;
			this._data = null;
		}
	}, {
		key: 'urlRequest',
		get: function get() {
			return this._urlRequest;
		}
	}, {
		key: 'status',
		get: function get() {
			return this._status;
		}
	}, {
		key: 'byteLoaded',
		get: function get() {
			return this._byteLoaded;
		}
	}, {
		key: 'byteTotal',
		get: function get() {
			return this._byteTotal;
		}

		/**
   * 加载的数据，未加载成功时返回null
   */

	}, {
		key: 'data',
		get: function get() {
			return this._data;
		}

		/**
   * 表示是否正在进行请求
   */

	}, {
		key: 'loading',
		get: function get() {
			return this._loading;
		}
	}]);

	return Loader;
}(_EventDispatcher3.default);

Loader.UNSTART = 1;
Loader.LOADING = 2;
Loader.COMPLETE = 3;
Loader.ERROR = 4;
exports.default = Loader;
//# sourceMappingURL=Loader.js.map