'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 
 * 
 * @author : xujunjie 
 * @mail   : yinhunfeixue@163.com
 * @date   : 2017/9/5 上午10:35:19
 */

var SystemUtil = function () {
	function SystemUtil() {
		_classCallCheck(this, SystemUtil);
	}

	_createClass(SystemUtil, null, [{
		key: 'isMobile',


		/**
   * 判断是否是移动端
   */
		value: function isMobile() {
			var ua = navigator.userAgent;
			var ipad = ua.match(/(iPad).*OS\s([\d_]+)/);
			var isIphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/);
			var isAndroid = ua.match(/(Android)\s+([\d.]+)/);
			return isIphone || isAndroid;
		}

		/**
    * 设置系统粘贴板的文字
    * @param {string} str 要复制的文本内容
    * @param {function} completeHandler 设置结束的处理函数，格式为fun(result)。 result表示复制结果，true表示复制成功，false表示复制失败
    */

	}, {
		key: 'copyText',
		value: function copyText(str, completeHandler) {
			var element = document.createElement('textarea');
			element.value = str;
			element.style.visibility = 'false';
			element.contentEditable = true;
			element.readOnly = false;
			document.body.appendChild(element);

			var range = document.createRange();
			range.selectNodeContents(element);

			var s = window.getSelection();
			s.removeAllRanges();
			s.addRange(range);
			element.select();
			element.setSelectionRange(0, 99999);

			var copyResult = true;
			try {
				document.execCommand('copy');
			} catch (error) {
				copyResult = false;
			} finally {
				element.blur();
				document.body.removeChild(element);
				if (completeHandler) completeHandler(copyResult);
			}
		}
	}]);

	return SystemUtil;
}();

exports.default = SystemUtil;
//# sourceMappingURL=SystemUtil.js.map